/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Swashbuckle.SwaggerGen.Annotations;
using IO.Swagger.Models;

namespace IO.Swagger.Controllers
{ 
    /// <summary>
    /// 
    /// </summary>
    public class DefaultApiController : Controller
    { 

        /// <summary>
        /// Аккаунт: баланс
        /// </summary>
        /// <remarks>Возвращает текущий баланс аккаунта</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Текущий баланс аккаунта хостинга</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/balance")]
        [SwaggerOperation("BalanceGet")]
        [SwaggerResponse(200, type: typeof(decimal?))]
        public virtual IActionResult BalanceGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<decimal?>(exampleJson)
            : default(decimal?);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Аккаунт: баланс аккаунта лицензий
        /// </summary>
        /// <remarks>Возвращает текущий баланс аккаунта лицензий</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Текущий баланс аккаунта лицензий</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/balance.lic")]
        [SwaggerOperation("BalanceLicGet")]
        [SwaggerResponse(200, type: typeof(decimal?))]
        public virtual IActionResult BalanceLicGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<decimal?>(exampleJson)
            : default(decimal?);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Информация по дебету аккаунта
        /// </summary>
        /// <remarks>Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Информация по дебету аккаунта</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/billing/debt")]
        [SwaggerOperation("BillingDebtGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse200>))]
        public virtual IActionResult BillingDebtGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse200>>(exampleJson)
            : default(List<InlineResponse200>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Информация об аккаунте
        /// </summary>
        /// <remarks>Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Информация об аккаунте</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/billing/info")]
        [SwaggerOperation("BillingInfoGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse2001>))]
        public virtual IActionResult BillingInfoGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse2001>>(exampleJson)
            : default(List<InlineResponse2001>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Получить ограничения аккаунта
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Ограничения аккаунта</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/billing/limits")]
        [SwaggerOperation("BillingLimitsGet")]
        [SwaggerResponse(200, type: typeof(_))]
        public virtual IActionResult BillingLimitsGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<_>(exampleJson)
            : default(_);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Информация по продлению доменов
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Информация по продлению доменов</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/dns/prolong/list")]
        [SwaggerOperation("DnsProlongListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse2004>))]
        public virtual IActionResult DnsProlongListGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse2004>>(exampleJson)
            : default(List<InlineResponse2004>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Создание почтового ящика
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="addEmail">Адрес почтового ящика, который необходимо создать</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/email/add")]
        [SwaggerOperation("EmailAddGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult EmailAddGet([FromQuery]string token_, [FromQuery]string addEmail)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Удаление псевдонимов почтовых ящиков
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/email/alias/delete")]
        [SwaggerOperation("EmailAliasDeleteGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult EmailAliasDeleteGet([FromQuery]string token_, [FromQuery]string key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Получить список псевдонимов почтовых ящиков
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Список псевдонимов почтовых ящиков</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/email/alias/list")]
        [SwaggerOperation("EmailAliasListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse2005>))]
        public virtual IActionResult EmailAliasListGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse2005>>(exampleJson)
            : default(List<InlineResponse2005>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Удаление почтового ящика
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">Адрес почтового ящика, подлежащего удалению</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/email/delete")]
        [SwaggerOperation("EmailDeleteGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult EmailDeleteGet([FromQuery]string token_, [FromQuery]string key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Получить список почтовых ящиков
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Список почтовых ящиков</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/email/list")]
        [SwaggerOperation("EmailListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse2006>))]
        public virtual IActionResult EmailListGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse2006>>(exampleJson)
            : default(List<InlineResponse2006>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Идентификатор последнего уведомления в аудите
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Идентификатор последнего уведомления в аудите</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/updates/last")]
        [SwaggerOperation("UpdatesLastGet")]
        [SwaggerResponse(200, type: typeof(int?))]
        public virtual IActionResult UpdatesLastGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<int?>(exampleJson)
            : default(int?);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Список записей аудита
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID первой записи для показа или 0 для показа всех записей</param>
        /// <response code="200">Список записей аудита</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/updates/list")]
        [SwaggerOperation("UpdatesListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse20010>))]
        public virtual IActionResult UpdatesListGet([FromQuery]string token_, [FromQuery]int? key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse20010>>(exampleJson)
            : default(List<InlineResponse20010>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Удаление сайта
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID сайта, полученный из /website/list</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/website/delete")]
        [SwaggerOperation("WebsiteDeleteGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult WebsiteDeleteGet([FromQuery]string token_, [FromQuery]string key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Список сайтов аккаунта
        /// </summary>
        
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Список сайтов аккаунта</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/website/list")]
        [SwaggerOperation("WebsiteListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse20014>))]
        public virtual IActionResult WebsiteListGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse20014>>(exampleJson)
            : default(List<InlineResponse20014>);
            return new ObjectResult(example);
        }
    }
}
