/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Swashbuckle.SwaggerGen.Annotations;
using IO.Swagger.Models;

namespace IO.Swagger.Controllers
{ 
    /// <summary>
    /// 
    /// </summary>
    public class VDSHyperVOpenVZApiController : Controller
    { 

        /// <summary>
        /// Изменение параметров VDS
        /// </summary>
        /// <remarks>Изменение параметров уже существующего VDS</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="type">Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2</param>
        /// <param name="template">Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list</param>
        /// <param name="forceMemo"></param>
        /// <param name="hv1gbPanelVersion"></param>
        /// <param name="panelInstall">Необходимо ли установить панель 1Gb на VDS</param>
        /// <param name="crSsd1">Создать всю систему на SSD</param>
        /// <param name="crHvAllSystem">Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)</param>
        /// <response code="200">ID VDS</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/create")]
        [SwaggerOperation("VdsCreateGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsCreateGet([FromQuery]string token_, [FromQuery]string type, [FromQuery]int? crHvmem, [FromQuery]int? crHvdsk, [FromQuery]int? crHvcpu, [FromQuery]string template, [FromQuery]string forceMemo, [FromQuery]string hv1gbPanelVersion, [FromQuery]bool? panelInstall, [FromQuery]bool? crSsd1, [FromQuery]bool? crHvAllSystem)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Удаление VDS
        /// </summary>
        /// <remarks>Предоставляет функционал для удаления VDS</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="forceCritical">Если true, VDS будет удален срочно</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/delete")]
        [SwaggerOperation("VdsDeleteGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsDeleteGet([FromQuery]string token_, [FromQuery]int? key_, [FromQuery]bool? forceCritical)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Добавление IP на VDS
        /// </summary>
        /// <remarks>Этот вызов позволяет добавить ещё один IP адрес на указанный VDS</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <response code="200">IP-адрес успешно добавлен</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/ip/add")]
        [SwaggerOperation("VdsIpAddGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsIpAddGet([FromQuery]string token_, [FromQuery]int? key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Удаление IP с VDS
        /// </summary>
        /// <remarks>Этот вызов позволяет отвязать IP адрес от VDS</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="delIp">IP адрес, который необходимо удалить</param>
        /// <response code="200">IP-адрес успешно удалён</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/ip/delete")]
        [SwaggerOperation("VdsIpDeleteGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsIpDeleteGet([FromQuery]string token_, [FromQuery]int? key_, [FromQuery]string delIp)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Список IP-адресов виртуальных серверов
        /// </summary>
        /// <remarks>Список IP-адресов виртуальных серверов</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <response code="200">Список IP-адресов виртуальных серверов</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/ip/list")]
        [SwaggerOperation("VdsIpListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse20011>))]
        public virtual IActionResult VdsIpListGet([FromQuery]string token_, [FromQuery]int? key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse20011>>(exampleJson)
            : default(List<InlineResponse20011>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Список виртуальных серверов
        /// </summary>
        /// <remarks>Позволяет получить список виртуальных серверов</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS</param>
        /// <response code="200">Список виртуальных серверов</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/list")]
        [SwaggerOperation("VdsListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse20012>))]
        public virtual IActionResult VdsListGet([FromQuery]string token_, [FromQuery]int? key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse20012>>(exampleJson)
            : default(List<InlineResponse20012>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Перезагрузка VDS
        /// </summary>
        /// <remarks>Предоставляет функционал для перезагрузки VDS</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <response code="200">Возврат строки &#39;OK&#39; означает успех операции</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/reboot")]
        [SwaggerOperation("VdsRebootGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsRebootGet([FromQuery]string token_, [FromQuery]int? key_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Список шаблонов виртуальных серверов
        /// </summary>
        /// <remarks>Позволяет получить список шаблонов виртуальных серверов</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <response code="200">Список шаблонов виртуальных серверов</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/templates-list")]
        [SwaggerOperation("VdsTemplatesListGet")]
        [SwaggerResponse(200, type: typeof(List<InlineResponse20013>))]
        public virtual IActionResult VdsTemplatesListGet([FromQuery]string token_)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<List<InlineResponse20013>>(exampleJson)
            : default(List<InlineResponse20013>);
            return new ObjectResult(example);
        }


        /// <summary>
        /// Создание VDS
        /// </summary>
        /// <remarks>Создание новых VDS с произвольными характеристиками</remarks>
        /// <param name="token_">Ключ доступа, полученный при авторизации</param>
        /// <param name="key_">ID виртуального сервера, полученный из /vds/list</param>
        /// <param name="crHvmem">Количество доступной памяти в мегабайтах. По умолчанию 2048</param>
        /// <param name="crHvdsk">Количество доступных гигабайт диска. По умолчанию 30</param>
        /// <param name="crHvcpu">Количество ядер CPU. По умолчанию 2</param>
        /// <response code="200">Параметры VDS успешно обновлены</response>
        /// <response code="0">Общая ошибка от сервера</response>
        [HttpGet]
        [Route("/vds/update")]
        [SwaggerOperation("VdsUpdateGet")]
        [SwaggerResponse(200, type: typeof(string))]
        public virtual IActionResult VdsUpdateGet([FromQuery]string token_, [FromQuery]int? key_, [FromQuery]int? crHvmem, [FromQuery]int? crHvdsk, [FromQuery]int? crHvcpu)
        { 
            string exampleJson = null;
            
            var example = exampleJson != null
            ? JsonConvert.DeserializeObject<string>(exampleJson)
            : default(string);
            return new ObjectResult(example);
        }
    }
}
