/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse2001 :  IEquatable<InlineResponse2001>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2001" /> class.
        /// </summary>
        /// <param name="Id">Идентификатор аккаунта (required).</param>
        /// <param name="Description">Описание аккаунта (required).</param>
        /// <param name="BillingGroupId">Идентификатор тарифной группы (required).</param>
        /// <param name="Blocked">Аккаунт заблокирован, если true (required).</param>
        /// <param name="BlockedDate">Дата блокировки.</param>
        /// <param name="BlockedReason">Причина блокировки.</param>
        /// <param name="CreditLimit">Ограничение суммы на работу в аванс (required).</param>
        /// <param name="PlanId">Идентификатор тарифа (required).</param>
        /// <param name="PeriodId">Идентификатор тарифа (периода) (required).</param>
        /// <param name="ContractType">Тип договора (required).</param>
        /// <param name="ClientId"> (required).</param>
        /// <param name="ClientLogin">Логин клиента (required).</param>
        /// <param name="ContractId">Номер договора (required).</param>
        /// <param name="NameRus">Имя клиента на русском (required).</param>
        /// <param name="NameEng">Имя клиента на английском (required).</param>
        /// <param name="Email">E-mail клиент (required).</param>
        /// <param name="StatSites">Количество созданных сайтов (required).</param>
        /// <param name="StatSizeMb">Используемое дисковое пространство (required).</param>
        /// <param name="StatEmails">Количество созданных почтовых ящиков (required).</param>
        /// <param name="StatMysqls">Количество баз данных MySQL (required).</param>
        /// <param name="StatTech"> (required).</param>
        /// <param name="StatNicd"> (required).</param>
        /// <param name="StatAccessDynamic"> (required).</param>
        /// <param name="StatAccessStatic"> (required).</param>
        /// <param name="StatAccessTraffic"> (required).</param>
        /// <param name="StatPaidTotal"> (required).</param>
        /// <param name="StatVdsSize">Размер дисков VDS (required).</param>
        /// <param name="PlanName">Название тарифного плана (required).</param>
        /// <param name="PeriodMonths">Количество месяцев в оплаченном периоде (required).</param>
        /// <param name="PeriodPrice">Стоимость оплаченного периода (required).</param>
        /// <param name="Expires"> (required).</param>
        /// <param name="ExternalCurrencySpelledPrefix">Префикс для вывода текущей валюты хостинга (например, в строке &#39;$100&#39; префиксом является &#39;$&#39;) (required).</param>
        /// <param name="ExternalCurrencySpelledSuffix">Суффикс для вывода текущей валюты хостинга (например, в строке &#39;100 руб.&#39; суффиксом является &#39; руб.&#39; (required).</param>
        public InlineResponse2001(int? Id = null, string Description = null, int? BillingGroupId = null, string Blocked = null, string BlockedDate = null, string BlockedReason = null, decimal? CreditLimit = null, int? PlanId = null, int? PeriodId = null, int? ContractType = null, int? ClientId = null, string ClientLogin = null, string ContractId = null, string NameRus = null, string NameEng = null, string Email = null, int? StatSites = null, int? StatSizeMb = null, int? StatEmails = null, int? StatMysqls = null, int? StatTech = null, int? StatNicd = null, int? StatAccessDynamic = null, int? StatAccessStatic = null, int? StatAccessTraffic = null, int? StatPaidTotal = null, int? StatVdsSize = null, string PlanName = null, int? PeriodMonths = null, decimal? PeriodPrice = null, string Expires = null, string ExternalCurrencySpelledPrefix = null, string ExternalCurrencySpelledSuffix = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Description" is required (not null)
            if (Description == null)
            {
                throw new InvalidDataException("Description is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.Description = Description;
            }
            // to ensure "BillingGroupId" is required (not null)
            if (BillingGroupId == null)
            {
                throw new InvalidDataException("BillingGroupId is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.BillingGroupId = BillingGroupId;
            }
            // to ensure "Blocked" is required (not null)
            if (Blocked == null)
            {
                throw new InvalidDataException("Blocked is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.Blocked = Blocked;
            }
            // to ensure "CreditLimit" is required (not null)
            if (CreditLimit == null)
            {
                throw new InvalidDataException("CreditLimit is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.CreditLimit = CreditLimit;
            }
            // to ensure "PlanId" is required (not null)
            if (PlanId == null)
            {
                throw new InvalidDataException("PlanId is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.PlanId = PlanId;
            }
            // to ensure "PeriodId" is required (not null)
            if (PeriodId == null)
            {
                throw new InvalidDataException("PeriodId is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.PeriodId = PeriodId;
            }
            // to ensure "ContractType" is required (not null)
            if (ContractType == null)
            {
                throw new InvalidDataException("ContractType is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ContractType = ContractType;
            }
            // to ensure "ClientId" is required (not null)
            if (ClientId == null)
            {
                throw new InvalidDataException("ClientId is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ClientId = ClientId;
            }
            // to ensure "ClientLogin" is required (not null)
            if (ClientLogin == null)
            {
                throw new InvalidDataException("ClientLogin is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ClientLogin = ClientLogin;
            }
            // to ensure "ContractId" is required (not null)
            if (ContractId == null)
            {
                throw new InvalidDataException("ContractId is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ContractId = ContractId;
            }
            // to ensure "NameRus" is required (not null)
            if (NameRus == null)
            {
                throw new InvalidDataException("NameRus is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.NameRus = NameRus;
            }
            // to ensure "NameEng" is required (not null)
            if (NameEng == null)
            {
                throw new InvalidDataException("NameEng is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.NameEng = NameEng;
            }
            // to ensure "Email" is required (not null)
            if (Email == null)
            {
                throw new InvalidDataException("Email is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.Email = Email;
            }
            // to ensure "StatSites" is required (not null)
            if (StatSites == null)
            {
                throw new InvalidDataException("StatSites is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatSites = StatSites;
            }
            // to ensure "StatSizeMb" is required (not null)
            if (StatSizeMb == null)
            {
                throw new InvalidDataException("StatSizeMb is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatSizeMb = StatSizeMb;
            }
            // to ensure "StatEmails" is required (not null)
            if (StatEmails == null)
            {
                throw new InvalidDataException("StatEmails is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatEmails = StatEmails;
            }
            // to ensure "StatMysqls" is required (not null)
            if (StatMysqls == null)
            {
                throw new InvalidDataException("StatMysqls is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatMysqls = StatMysqls;
            }
            // to ensure "StatTech" is required (not null)
            if (StatTech == null)
            {
                throw new InvalidDataException("StatTech is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatTech = StatTech;
            }
            // to ensure "StatNicd" is required (not null)
            if (StatNicd == null)
            {
                throw new InvalidDataException("StatNicd is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatNicd = StatNicd;
            }
            // to ensure "StatAccessDynamic" is required (not null)
            if (StatAccessDynamic == null)
            {
                throw new InvalidDataException("StatAccessDynamic is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatAccessDynamic = StatAccessDynamic;
            }
            // to ensure "StatAccessStatic" is required (not null)
            if (StatAccessStatic == null)
            {
                throw new InvalidDataException("StatAccessStatic is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatAccessStatic = StatAccessStatic;
            }
            // to ensure "StatAccessTraffic" is required (not null)
            if (StatAccessTraffic == null)
            {
                throw new InvalidDataException("StatAccessTraffic is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatAccessTraffic = StatAccessTraffic;
            }
            // to ensure "StatPaidTotal" is required (not null)
            if (StatPaidTotal == null)
            {
                throw new InvalidDataException("StatPaidTotal is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatPaidTotal = StatPaidTotal;
            }
            // to ensure "StatVdsSize" is required (not null)
            if (StatVdsSize == null)
            {
                throw new InvalidDataException("StatVdsSize is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.StatVdsSize = StatVdsSize;
            }
            // to ensure "PlanName" is required (not null)
            if (PlanName == null)
            {
                throw new InvalidDataException("PlanName is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.PlanName = PlanName;
            }
            // to ensure "PeriodMonths" is required (not null)
            if (PeriodMonths == null)
            {
                throw new InvalidDataException("PeriodMonths is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.PeriodMonths = PeriodMonths;
            }
            // to ensure "PeriodPrice" is required (not null)
            if (PeriodPrice == null)
            {
                throw new InvalidDataException("PeriodPrice is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.PeriodPrice = PeriodPrice;
            }
            // to ensure "Expires" is required (not null)
            if (Expires == null)
            {
                throw new InvalidDataException("Expires is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.Expires = Expires;
            }
            // to ensure "ExternalCurrencySpelledPrefix" is required (not null)
            if (ExternalCurrencySpelledPrefix == null)
            {
                throw new InvalidDataException("ExternalCurrencySpelledPrefix is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ExternalCurrencySpelledPrefix = ExternalCurrencySpelledPrefix;
            }
            // to ensure "ExternalCurrencySpelledSuffix" is required (not null)
            if (ExternalCurrencySpelledSuffix == null)
            {
                throw new InvalidDataException("ExternalCurrencySpelledSuffix is a required property for InlineResponse2001 and cannot be null");
            }
            else
            {
                this.ExternalCurrencySpelledSuffix = ExternalCurrencySpelledSuffix;
            }
            this.BlockedDate = BlockedDate;
            this.BlockedReason = BlockedReason;
            
        }

        /// <summary>
        /// Идентификатор аккаунта
        /// </summary>
        /// <value>Идентификатор аккаунта</value>
        public int? Id { get; set; }

        /// <summary>
        /// Описание аккаунта
        /// </summary>
        /// <value>Описание аккаунта</value>
        public string Description { get; set; }

        /// <summary>
        /// Идентификатор тарифной группы
        /// </summary>
        /// <value>Идентификатор тарифной группы</value>
        public int? BillingGroupId { get; set; }

        /// <summary>
        /// Аккаунт заблокирован, если true
        /// </summary>
        /// <value>Аккаунт заблокирован, если true</value>
        public string Blocked { get; set; }

        /// <summary>
        /// Дата блокировки
        /// </summary>
        /// <value>Дата блокировки</value>
        public string BlockedDate { get; set; }

        /// <summary>
        /// Причина блокировки
        /// </summary>
        /// <value>Причина блокировки</value>
        public string BlockedReason { get; set; }

        /// <summary>
        /// Ограничение суммы на работу в аванс
        /// </summary>
        /// <value>Ограничение суммы на работу в аванс</value>
        public decimal? CreditLimit { get; set; }

        /// <summary>
        /// Идентификатор тарифа
        /// </summary>
        /// <value>Идентификатор тарифа</value>
        public int? PlanId { get; set; }

        /// <summary>
        /// Идентификатор тарифа (периода)
        /// </summary>
        /// <value>Идентификатор тарифа (периода)</value>
        public int? PeriodId { get; set; }

        /// <summary>
        /// Тип договора
        /// </summary>
        /// <value>Тип договора</value>
        public int? ContractType { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? ClientId { get; set; }

        /// <summary>
        /// Логин клиента
        /// </summary>
        /// <value>Логин клиента</value>
        public string ClientLogin { get; set; }

        /// <summary>
        /// Номер договора
        /// </summary>
        /// <value>Номер договора</value>
        public string ContractId { get; set; }

        /// <summary>
        /// Имя клиента на русском
        /// </summary>
        /// <value>Имя клиента на русском</value>
        public string NameRus { get; set; }

        /// <summary>
        /// Имя клиента на английском
        /// </summary>
        /// <value>Имя клиента на английском</value>
        public string NameEng { get; set; }

        /// <summary>
        /// E-mail клиент
        /// </summary>
        /// <value>E-mail клиент</value>
        public string Email { get; set; }

        /// <summary>
        /// Количество созданных сайтов
        /// </summary>
        /// <value>Количество созданных сайтов</value>
        public int? StatSites { get; set; }

        /// <summary>
        /// Используемое дисковое пространство
        /// </summary>
        /// <value>Используемое дисковое пространство</value>
        public int? StatSizeMb { get; set; }

        /// <summary>
        /// Количество созданных почтовых ящиков
        /// </summary>
        /// <value>Количество созданных почтовых ящиков</value>
        public int? StatEmails { get; set; }

        /// <summary>
        /// Количество баз данных MySQL
        /// </summary>
        /// <value>Количество баз данных MySQL</value>
        public int? StatMysqls { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatTech { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatNicd { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatAccessDynamic { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatAccessStatic { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatAccessTraffic { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? StatPaidTotal { get; set; }

        /// <summary>
        /// Размер дисков VDS
        /// </summary>
        /// <value>Размер дисков VDS</value>
        public int? StatVdsSize { get; set; }

        /// <summary>
        /// Название тарифного плана
        /// </summary>
        /// <value>Название тарифного плана</value>
        public string PlanName { get; set; }

        /// <summary>
        /// Количество месяцев в оплаченном периоде
        /// </summary>
        /// <value>Количество месяцев в оплаченном периоде</value>
        public int? PeriodMonths { get; set; }

        /// <summary>
        /// Стоимость оплаченного периода
        /// </summary>
        /// <value>Стоимость оплаченного периода</value>
        public decimal? PeriodPrice { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Expires { get; set; }

        /// <summary>
        /// Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')
        /// </summary>
        /// <value>Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')</value>
        public string ExternalCurrencySpelledPrefix { get; set; }

        /// <summary>
        /// Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'
        /// </summary>
        /// <value>Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'</value>
        public string ExternalCurrencySpelledSuffix { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2001 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Description: ").Append(Description).Append("\n");
sb.Append("  BillingGroupId: ").Append(BillingGroupId).Append("\n");
sb.Append("  Blocked: ").Append(Blocked).Append("\n");
sb.Append("  BlockedDate: ").Append(BlockedDate).Append("\n");
sb.Append("  BlockedReason: ").Append(BlockedReason).Append("\n");
sb.Append("  CreditLimit: ").Append(CreditLimit).Append("\n");
sb.Append("  PlanId: ").Append(PlanId).Append("\n");
sb.Append("  PeriodId: ").Append(PeriodId).Append("\n");
sb.Append("  ContractType: ").Append(ContractType).Append("\n");
sb.Append("  ClientId: ").Append(ClientId).Append("\n");
sb.Append("  ClientLogin: ").Append(ClientLogin).Append("\n");
sb.Append("  ContractId: ").Append(ContractId).Append("\n");
sb.Append("  NameRus: ").Append(NameRus).Append("\n");
sb.Append("  NameEng: ").Append(NameEng).Append("\n");
sb.Append("  Email: ").Append(Email).Append("\n");
sb.Append("  StatSites: ").Append(StatSites).Append("\n");
sb.Append("  StatSizeMb: ").Append(StatSizeMb).Append("\n");
sb.Append("  StatEmails: ").Append(StatEmails).Append("\n");
sb.Append("  StatMysqls: ").Append(StatMysqls).Append("\n");
sb.Append("  StatTech: ").Append(StatTech).Append("\n");
sb.Append("  StatNicd: ").Append(StatNicd).Append("\n");
sb.Append("  StatAccessDynamic: ").Append(StatAccessDynamic).Append("\n");
sb.Append("  StatAccessStatic: ").Append(StatAccessStatic).Append("\n");
sb.Append("  StatAccessTraffic: ").Append(StatAccessTraffic).Append("\n");
sb.Append("  StatPaidTotal: ").Append(StatPaidTotal).Append("\n");
sb.Append("  StatVdsSize: ").Append(StatVdsSize).Append("\n");
sb.Append("  PlanName: ").Append(PlanName).Append("\n");
sb.Append("  PeriodMonths: ").Append(PeriodMonths).Append("\n");
sb.Append("  PeriodPrice: ").Append(PeriodPrice).Append("\n");
sb.Append("  Expires: ").Append(Expires).Append("\n");
sb.Append("  ExternalCurrencySpelledPrefix: ").Append(ExternalCurrencySpelledPrefix).Append("\n");
sb.Append("  ExternalCurrencySpelledSuffix: ").Append(ExternalCurrencySpelledSuffix).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse2001)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse2001 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2001 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2001 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Description == other.Description ||
                    this.Description != null &&
                    this.Description.Equals(other.Description)
                ) && 
                (
                    this.BillingGroupId == other.BillingGroupId ||
                    this.BillingGroupId != null &&
                    this.BillingGroupId.Equals(other.BillingGroupId)
                ) && 
                (
                    this.Blocked == other.Blocked ||
                    this.Blocked != null &&
                    this.Blocked.Equals(other.Blocked)
                ) && 
                (
                    this.BlockedDate == other.BlockedDate ||
                    this.BlockedDate != null &&
                    this.BlockedDate.Equals(other.BlockedDate)
                ) && 
                (
                    this.BlockedReason == other.BlockedReason ||
                    this.BlockedReason != null &&
                    this.BlockedReason.Equals(other.BlockedReason)
                ) && 
                (
                    this.CreditLimit == other.CreditLimit ||
                    this.CreditLimit != null &&
                    this.CreditLimit.Equals(other.CreditLimit)
                ) && 
                (
                    this.PlanId == other.PlanId ||
                    this.PlanId != null &&
                    this.PlanId.Equals(other.PlanId)
                ) && 
                (
                    this.PeriodId == other.PeriodId ||
                    this.PeriodId != null &&
                    this.PeriodId.Equals(other.PeriodId)
                ) && 
                (
                    this.ContractType == other.ContractType ||
                    this.ContractType != null &&
                    this.ContractType.Equals(other.ContractType)
                ) && 
                (
                    this.ClientId == other.ClientId ||
                    this.ClientId != null &&
                    this.ClientId.Equals(other.ClientId)
                ) && 
                (
                    this.ClientLogin == other.ClientLogin ||
                    this.ClientLogin != null &&
                    this.ClientLogin.Equals(other.ClientLogin)
                ) && 
                (
                    this.ContractId == other.ContractId ||
                    this.ContractId != null &&
                    this.ContractId.Equals(other.ContractId)
                ) && 
                (
                    this.NameRus == other.NameRus ||
                    this.NameRus != null &&
                    this.NameRus.Equals(other.NameRus)
                ) && 
                (
                    this.NameEng == other.NameEng ||
                    this.NameEng != null &&
                    this.NameEng.Equals(other.NameEng)
                ) && 
                (
                    this.Email == other.Email ||
                    this.Email != null &&
                    this.Email.Equals(other.Email)
                ) && 
                (
                    this.StatSites == other.StatSites ||
                    this.StatSites != null &&
                    this.StatSites.Equals(other.StatSites)
                ) && 
                (
                    this.StatSizeMb == other.StatSizeMb ||
                    this.StatSizeMb != null &&
                    this.StatSizeMb.Equals(other.StatSizeMb)
                ) && 
                (
                    this.StatEmails == other.StatEmails ||
                    this.StatEmails != null &&
                    this.StatEmails.Equals(other.StatEmails)
                ) && 
                (
                    this.StatMysqls == other.StatMysqls ||
                    this.StatMysqls != null &&
                    this.StatMysqls.Equals(other.StatMysqls)
                ) && 
                (
                    this.StatTech == other.StatTech ||
                    this.StatTech != null &&
                    this.StatTech.Equals(other.StatTech)
                ) && 
                (
                    this.StatNicd == other.StatNicd ||
                    this.StatNicd != null &&
                    this.StatNicd.Equals(other.StatNicd)
                ) && 
                (
                    this.StatAccessDynamic == other.StatAccessDynamic ||
                    this.StatAccessDynamic != null &&
                    this.StatAccessDynamic.Equals(other.StatAccessDynamic)
                ) && 
                (
                    this.StatAccessStatic == other.StatAccessStatic ||
                    this.StatAccessStatic != null &&
                    this.StatAccessStatic.Equals(other.StatAccessStatic)
                ) && 
                (
                    this.StatAccessTraffic == other.StatAccessTraffic ||
                    this.StatAccessTraffic != null &&
                    this.StatAccessTraffic.Equals(other.StatAccessTraffic)
                ) && 
                (
                    this.StatPaidTotal == other.StatPaidTotal ||
                    this.StatPaidTotal != null &&
                    this.StatPaidTotal.Equals(other.StatPaidTotal)
                ) && 
                (
                    this.StatVdsSize == other.StatVdsSize ||
                    this.StatVdsSize != null &&
                    this.StatVdsSize.Equals(other.StatVdsSize)
                ) && 
                (
                    this.PlanName == other.PlanName ||
                    this.PlanName != null &&
                    this.PlanName.Equals(other.PlanName)
                ) && 
                (
                    this.PeriodMonths == other.PeriodMonths ||
                    this.PeriodMonths != null &&
                    this.PeriodMonths.Equals(other.PeriodMonths)
                ) && 
                (
                    this.PeriodPrice == other.PeriodPrice ||
                    this.PeriodPrice != null &&
                    this.PeriodPrice.Equals(other.PeriodPrice)
                ) && 
                (
                    this.Expires == other.Expires ||
                    this.Expires != null &&
                    this.Expires.Equals(other.Expires)
                ) && 
                (
                    this.ExternalCurrencySpelledPrefix == other.ExternalCurrencySpelledPrefix ||
                    this.ExternalCurrencySpelledPrefix != null &&
                    this.ExternalCurrencySpelledPrefix.Equals(other.ExternalCurrencySpelledPrefix)
                ) && 
                (
                    this.ExternalCurrencySpelledSuffix == other.ExternalCurrencySpelledSuffix ||
                    this.ExternalCurrencySpelledSuffix != null &&
                    this.ExternalCurrencySpelledSuffix.Equals(other.ExternalCurrencySpelledSuffix)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Description != null)
                    hash = hash * 59 + this.Description.GetHashCode();
                    if (this.BillingGroupId != null)
                    hash = hash * 59 + this.BillingGroupId.GetHashCode();
                    if (this.Blocked != null)
                    hash = hash * 59 + this.Blocked.GetHashCode();
                    if (this.BlockedDate != null)
                    hash = hash * 59 + this.BlockedDate.GetHashCode();
                    if (this.BlockedReason != null)
                    hash = hash * 59 + this.BlockedReason.GetHashCode();
                    if (this.CreditLimit != null)
                    hash = hash * 59 + this.CreditLimit.GetHashCode();
                    if (this.PlanId != null)
                    hash = hash * 59 + this.PlanId.GetHashCode();
                    if (this.PeriodId != null)
                    hash = hash * 59 + this.PeriodId.GetHashCode();
                    if (this.ContractType != null)
                    hash = hash * 59 + this.ContractType.GetHashCode();
                    if (this.ClientId != null)
                    hash = hash * 59 + this.ClientId.GetHashCode();
                    if (this.ClientLogin != null)
                    hash = hash * 59 + this.ClientLogin.GetHashCode();
                    if (this.ContractId != null)
                    hash = hash * 59 + this.ContractId.GetHashCode();
                    if (this.NameRus != null)
                    hash = hash * 59 + this.NameRus.GetHashCode();
                    if (this.NameEng != null)
                    hash = hash * 59 + this.NameEng.GetHashCode();
                    if (this.Email != null)
                    hash = hash * 59 + this.Email.GetHashCode();
                    if (this.StatSites != null)
                    hash = hash * 59 + this.StatSites.GetHashCode();
                    if (this.StatSizeMb != null)
                    hash = hash * 59 + this.StatSizeMb.GetHashCode();
                    if (this.StatEmails != null)
                    hash = hash * 59 + this.StatEmails.GetHashCode();
                    if (this.StatMysqls != null)
                    hash = hash * 59 + this.StatMysqls.GetHashCode();
                    if (this.StatTech != null)
                    hash = hash * 59 + this.StatTech.GetHashCode();
                    if (this.StatNicd != null)
                    hash = hash * 59 + this.StatNicd.GetHashCode();
                    if (this.StatAccessDynamic != null)
                    hash = hash * 59 + this.StatAccessDynamic.GetHashCode();
                    if (this.StatAccessStatic != null)
                    hash = hash * 59 + this.StatAccessStatic.GetHashCode();
                    if (this.StatAccessTraffic != null)
                    hash = hash * 59 + this.StatAccessTraffic.GetHashCode();
                    if (this.StatPaidTotal != null)
                    hash = hash * 59 + this.StatPaidTotal.GetHashCode();
                    if (this.StatVdsSize != null)
                    hash = hash * 59 + this.StatVdsSize.GetHashCode();
                    if (this.PlanName != null)
                    hash = hash * 59 + this.PlanName.GetHashCode();
                    if (this.PeriodMonths != null)
                    hash = hash * 59 + this.PeriodMonths.GetHashCode();
                    if (this.PeriodPrice != null)
                    hash = hash * 59 + this.PeriodPrice.GetHashCode();
                    if (this.Expires != null)
                    hash = hash * 59 + this.Expires.GetHashCode();
                    if (this.ExternalCurrencySpelledPrefix != null)
                    hash = hash * 59 + this.ExternalCurrencySpelledPrefix.GetHashCode();
                    if (this.ExternalCurrencySpelledSuffix != null)
                    hash = hash * 59 + this.ExternalCurrencySpelledSuffix.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse2001 left, InlineResponse2001 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse2001 left, InlineResponse2001 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
