/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse20012 :  IEquatable<InlineResponse20012>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse20012" /> class.
        /// </summary>
        /// <param name="Id">идентификатор VDS (required).</param>
        /// <param name="Deleted">VDS удалён если true (required).</param>
        /// <param name="Online">VDS работает нормально если true (required).</param>
        /// <param name="Stopped">VDS остановлен если true (required).</param>
        /// <param name="Pwd">изначальный пароль администратора или root (required).</param>
        /// <param name="Template">шаблон, на основе которого был создан VDS (required).</param>
        /// <param name="TypeFull">полное описание типа VDS (required).</param>
        /// <param name="PhysicalMac">MAC-адрес VDS (required).</param>
        /// <param name="Type">тип VDS (required).</param>
        public InlineResponse20012(int? Id = null, bool? Deleted = null, bool? Online = null, bool? Stopped = null, string Pwd = null, string Template = null, string TypeFull = null, string PhysicalMac = null, string Type = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Deleted" is required (not null)
            if (Deleted == null)
            {
                throw new InvalidDataException("Deleted is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Deleted = Deleted;
            }
            // to ensure "Online" is required (not null)
            if (Online == null)
            {
                throw new InvalidDataException("Online is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Online = Online;
            }
            // to ensure "Stopped" is required (not null)
            if (Stopped == null)
            {
                throw new InvalidDataException("Stopped is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Stopped = Stopped;
            }
            // to ensure "Pwd" is required (not null)
            if (Pwd == null)
            {
                throw new InvalidDataException("Pwd is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Pwd = Pwd;
            }
            // to ensure "Template" is required (not null)
            if (Template == null)
            {
                throw new InvalidDataException("Template is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Template = Template;
            }
            // to ensure "TypeFull" is required (not null)
            if (TypeFull == null)
            {
                throw new InvalidDataException("TypeFull is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.TypeFull = TypeFull;
            }
            // to ensure "PhysicalMac" is required (not null)
            if (PhysicalMac == null)
            {
                throw new InvalidDataException("PhysicalMac is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.PhysicalMac = PhysicalMac;
            }
            // to ensure "Type" is required (not null)
            if (Type == null)
            {
                throw new InvalidDataException("Type is a required property for InlineResponse20012 and cannot be null");
            }
            else
            {
                this.Type = Type;
            }
            
        }

        /// <summary>
        /// идентификатор VDS
        /// </summary>
        /// <value>идентификатор VDS</value>
        public int? Id { get; set; }

        /// <summary>
        /// VDS удалён если true
        /// </summary>
        /// <value>VDS удалён если true</value>
        public bool? Deleted { get; set; }

        /// <summary>
        /// VDS работает нормально если true
        /// </summary>
        /// <value>VDS работает нормально если true</value>
        public bool? Online { get; set; }

        /// <summary>
        /// VDS остановлен если true
        /// </summary>
        /// <value>VDS остановлен если true</value>
        public bool? Stopped { get; set; }

        /// <summary>
        /// изначальный пароль администратора или root
        /// </summary>
        /// <value>изначальный пароль администратора или root</value>
        public string Pwd { get; set; }

        /// <summary>
        /// шаблон, на основе которого был создан VDS
        /// </summary>
        /// <value>шаблон, на основе которого был создан VDS</value>
        public string Template { get; set; }

        /// <summary>
        /// полное описание типа VDS
        /// </summary>
        /// <value>полное описание типа VDS</value>
        public string TypeFull { get; set; }

        /// <summary>
        /// MAC-адрес VDS
        /// </summary>
        /// <value>MAC-адрес VDS</value>
        public string PhysicalMac { get; set; }

        /// <summary>
        /// тип VDS
        /// </summary>
        /// <value>тип VDS</value>
        public string Type { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse20012 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Deleted: ").Append(Deleted).Append("\n");
sb.Append("  Online: ").Append(Online).Append("\n");
sb.Append("  Stopped: ").Append(Stopped).Append("\n");
sb.Append("  Pwd: ").Append(Pwd).Append("\n");
sb.Append("  Template: ").Append(Template).Append("\n");
sb.Append("  TypeFull: ").Append(TypeFull).Append("\n");
sb.Append("  PhysicalMac: ").Append(PhysicalMac).Append("\n");
sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse20012)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse20012 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse20012 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse20012 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Deleted == other.Deleted ||
                    this.Deleted != null &&
                    this.Deleted.Equals(other.Deleted)
                ) && 
                (
                    this.Online == other.Online ||
                    this.Online != null &&
                    this.Online.Equals(other.Online)
                ) && 
                (
                    this.Stopped == other.Stopped ||
                    this.Stopped != null &&
                    this.Stopped.Equals(other.Stopped)
                ) && 
                (
                    this.Pwd == other.Pwd ||
                    this.Pwd != null &&
                    this.Pwd.Equals(other.Pwd)
                ) && 
                (
                    this.Template == other.Template ||
                    this.Template != null &&
                    this.Template.Equals(other.Template)
                ) && 
                (
                    this.TypeFull == other.TypeFull ||
                    this.TypeFull != null &&
                    this.TypeFull.Equals(other.TypeFull)
                ) && 
                (
                    this.PhysicalMac == other.PhysicalMac ||
                    this.PhysicalMac != null &&
                    this.PhysicalMac.Equals(other.PhysicalMac)
                ) && 
                (
                    this.Type == other.Type ||
                    this.Type != null &&
                    this.Type.Equals(other.Type)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Deleted != null)
                    hash = hash * 59 + this.Deleted.GetHashCode();
                    if (this.Online != null)
                    hash = hash * 59 + this.Online.GetHashCode();
                    if (this.Stopped != null)
                    hash = hash * 59 + this.Stopped.GetHashCode();
                    if (this.Pwd != null)
                    hash = hash * 59 + this.Pwd.GetHashCode();
                    if (this.Template != null)
                    hash = hash * 59 + this.Template.GetHashCode();
                    if (this.TypeFull != null)
                    hash = hash * 59 + this.TypeFull.GetHashCode();
                    if (this.PhysicalMac != null)
                    hash = hash * 59 + this.PhysicalMac.GetHashCode();
                    if (this.Type != null)
                    hash = hash * 59 + this.Type.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse20012 left, InlineResponse20012 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse20012 left, InlineResponse20012 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
