/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse20014 :  IEquatable<InlineResponse20014>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse20014" /> class.
        /// </summary>
        /// <param name="Id"> (required).</param>
        /// <param name="Status"> (required).</param>
        /// <param name="Unmovable"> (required).</param>
        /// <param name="Online">Включен (активен), если true. (required).</param>
        /// <param name="Deleted">Удален, если true. Данные могут сохраняться. (required).</param>
        /// <param name="DeletedAuto">Удален, если true. Данные могут сохраняться. (required).</param>
        /// <param name="DeletedDump"> (required).</param>
        /// <param name="UserId"> (required).</param>
        /// <param name="FtpId"> (required).</param>
        /// <param name="DnsId"> (required).</param>
        /// <param name="IisId"> (required).</param>
        /// <param name="IisBinding"> (required).</param>
        /// <param name="IisPath"> (required).</param>
        /// <param name="IisComments">Уникальное строковое имя сайта (ID). (required).</param>
        /// <param name="Memo"> (required).</param>
        /// <param name="DateReg">Дата создания. (required).</param>
        /// <param name="Server">Тип веб-сервера. (required).</param>
        /// <param name="ServerBak"> (required).</param>
        /// <param name="ServerAux"> (required).</param>
        /// <param name="ServerTransition">Тип сервера недавно изменялся, если true. (required).</param>
        /// <param name="ServerTransitionDtc"> (required).</param>
        /// <param name="BlockTransfer"> (required).</param>
        /// <param name="ServerChangedTime"> (required).</param>
        /// <param name="SizeAmount">Размер веб-сайта - объем (Кб). (required).</param>
        /// <param name="SizeFileCount">Размер веб-сайта - кол-во файлов. (required).</param>
        /// <param name="SizeFileCountLimit"> (required).</param>
        /// <param name="SizeDate">Размер веб-сайта - дата замера. (required).</param>
        /// <param name="SizePriorityScan"> (required).</param>
        /// <param name="CopyLogs"> (required).</param>
        /// <param name="ContentComments"> (required).</param>
        /// <param name="ContentCommentsVerbose"> (required).</param>
        /// <param name="MetaSaveCount"> (required).</param>
        /// <param name="BaseFolder"> (required).</param>
        /// <param name="VirtualhostConf"> (required).</param>
        /// <param name="VirtualhostServer"> (required).</param>
        /// <param name="VirtualhostServerConf"> (required).</param>
        /// <param name="LiveDayCount"> (required).</param>
        /// <param name="ScanDate"> (required).</param>
        /// <param name="GlobalTransferCount"> (required).</param>
        /// <param name="NetLimitFile"> (required).</param>
        /// <param name="NetLimitDenyFromIp"> (required).</param>
        /// <param name="NetLimitDenyFromAgent"> (required).</param>
        /// <param name="ApachePhpPooled"> (required).</param>
        /// <param name="ApachePhpPooledExt"> (required).</param>
        /// <param name="ApachePhpPooledExtAuto"> (required).</param>
        /// <param name="ApachePhpPool1Only"> (required).</param>
        /// <param name="ApachePhpPool5Only"> (required).</param>
        /// <param name="ApacheSsi"> (required).</param>
        /// <param name="BypassSecurity"> (required).</param>
        /// <param name="FlagGenericExec"> (required).</param>
        /// <param name="FlagNoWww"> (required).</param>
        /// <param name="BaseFolderSuffix"> (required).</param>
        /// <param name="FeedbackSpeed"> (required).</param>
        /// <param name="FeedbackSpeedDtc"> (required).</param>
        /// <param name="FeedbackSpeedFeedback"> (required).</param>
        /// <param name="UnixPathOnWindows"> (required).</param>
        /// <param name="FtpIpfilter">Ограничение по IP адресам - FTP доступ. (required).</param>
        /// <param name="SshIpfilter">Ограничение по IP адресам - SSH доступ. (required).</param>
        /// <param name="L3dAuto"> (required).</param>
        /// <param name="AwstatsPrimaryDomain"> (required).</param>
        /// <param name="SharepointMode"> (required).</param>
        /// <param name="SharepointModePending"> (required).</param>
        /// <param name="ApacheGenericPoolPort"> (required).</param>
        /// <param name="MongrelEnvironment"> (required).</param>
        /// <param name="FlagFree"> (required).</param>
        /// <param name="RtmScanDate"> (required).</param>
        /// <param name="AnalyzeAnalog"> (required).</param>
        /// <param name="CpuDetailsEnabled">Включен режим предоставления детализации процессорной нагрузки. (required).</param>
        /// <param name="ContentModeratedStatus"> (required).</param>
        /// <param name="ContentModeratedDate"> (required).</param>
        /// <param name="HttpFrontendIp"> (required).</param>
        /// <param name="HttpFrontendIpTransition"> (required).</param>
        /// <param name="CpuLimitExceededDate">Дата последнего превышения процессорной нагрузки. (required).</param>
        /// <param name="AufsTemplate">Признак сайта-конструктора. (required).</param>
        /// <param name="OptionsAutolimit"> (required).</param>
        /// <param name="IisCreationCommands">Версия ASP.NET, если отлична от 2.0. (required).</param>
        /// <param name="IisCreationCommandsUnix"> (required).</param>
        /// <param name="ThumbDate"> (required).</param>
        /// <param name="ThumbFailed"> (required).</param>
        /// <param name="BackupStatDate"> (required).</param>
        /// <param name="BackupDate">Дата пофайловой резервной копии. (required).</param>
        /// <param name="DetectedPackages"> (required).</param>
        /// <param name="StatSitePower"> (required).</param>
        /// <param name="SmtpFrom"> (required).</param>
        /// <param name="SuperBackupDate"> (required).</param>
        /// <param name="BackupDeltaStatDate"> (required).</param>
        /// <param name="BackupDeltaDate">Дата архивной резервной копии. (required).</param>
        /// <param name="BackupDeltaDesc">Содержимое архивной резервной копии. (required).</param>
        /// <param name="AltDocrootServer"> (required).</param>
        /// <param name="AltDocrootPath"> (required).</param>
        /// <param name="AltDocrootStatus"> (required).</param>
        /// <param name="AltDocrootStatusCnt"> (required).</param>
        /// <param name="AltDocrootStatusDate"> (required).</param>
        /// <param name="BindDtc">Последнее изменение привязок доменов для сайта. (required).</param>
        /// <param name="BackupSpecialMode"> (required).</param>
        /// <param name="SizeCheckProblem"> (required).</param>
        /// <param name="WpbDomain"> (required).</param>
        /// <param name="WpbUuid">Для сайта включен конструктор Parallels WPB. (required).</param>
        /// <param name="WpbStatus"> (required).</param>
        /// <param name="AdminProtection"> (required).</param>
        /// <param name="SizeComments"> (required).</param>
        /// <param name="AltDocrootSsdReq"> (required).</param>
        /// <param name="MailLimit"> (required).</param>
        /// <param name="MailAccept"> (required).</param>
        /// <param name="MailDrop"> (required).</param>
        /// <param name="FtpName">FTP/SSH/SCP/SFTP логин. (required).</param>
        /// <param name="FtpPwd">FTP/SSH/SCP/SFTP пароль. (required).</param>
        public InlineResponse20014(int? Id = null, string Status = null, string Unmovable = null, string Online = null, string Deleted = null, string DeletedAuto = null, string DeletedDump = null, string UserId = null, string FtpId = null, string DnsId = null, string IisId = null, string IisBinding = null, string IisPath = null, string IisComments = null, string Memo = null, string DateReg = null, string Server = null, string ServerBak = null, string ServerAux = null, string ServerTransition = null, string ServerTransitionDtc = null, string BlockTransfer = null, string ServerChangedTime = null, string SizeAmount = null, string SizeFileCount = null, string SizeFileCountLimit = null, string SizeDate = null, string SizePriorityScan = null, string CopyLogs = null, string ContentComments = null, string ContentCommentsVerbose = null, string MetaSaveCount = null, string BaseFolder = null, string VirtualhostConf = null, string VirtualhostServer = null, string VirtualhostServerConf = null, string LiveDayCount = null, string ScanDate = null, string GlobalTransferCount = null, string NetLimitFile = null, string NetLimitDenyFromIp = null, string NetLimitDenyFromAgent = null, string ApachePhpPooled = null, string ApachePhpPooledExt = null, string ApachePhpPooledExtAuto = null, string ApachePhpPool1Only = null, string ApachePhpPool5Only = null, string ApacheSsi = null, string BypassSecurity = null, string FlagGenericExec = null, string FlagNoWww = null, string BaseFolderSuffix = null, string FeedbackSpeed = null, string FeedbackSpeedDtc = null, string FeedbackSpeedFeedback = null, string UnixPathOnWindows = null, string FtpIpfilter = null, string SshIpfilter = null, string L3dAuto = null, string AwstatsPrimaryDomain = null, string SharepointMode = null, string SharepointModePending = null, string ApacheGenericPoolPort = null, string MongrelEnvironment = null, string FlagFree = null, string RtmScanDate = null, string AnalyzeAnalog = null, string CpuDetailsEnabled = null, string ContentModeratedStatus = null, string ContentModeratedDate = null, string HttpFrontendIp = null, string HttpFrontendIpTransition = null, string CpuLimitExceededDate = null, string AufsTemplate = null, string OptionsAutolimit = null, string IisCreationCommands = null, string IisCreationCommandsUnix = null, string ThumbDate = null, string ThumbFailed = null, string BackupStatDate = null, string BackupDate = null, string DetectedPackages = null, string StatSitePower = null, string SmtpFrom = null, string SuperBackupDate = null, string BackupDeltaStatDate = null, string BackupDeltaDate = null, string BackupDeltaDesc = null, string AltDocrootServer = null, string AltDocrootPath = null, string AltDocrootStatus = null, string AltDocrootStatusCnt = null, string AltDocrootStatusDate = null, string BindDtc = null, string BackupSpecialMode = null, string SizeCheckProblem = null, string WpbDomain = null, string WpbUuid = null, string WpbStatus = null, string AdminProtection = null, string SizeComments = null, string AltDocrootSsdReq = null, string MailLimit = null, string MailAccept = null, string MailDrop = null, string FtpName = null, string FtpPwd = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Status" is required (not null)
            if (Status == null)
            {
                throw new InvalidDataException("Status is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Status = Status;
            }
            // to ensure "Unmovable" is required (not null)
            if (Unmovable == null)
            {
                throw new InvalidDataException("Unmovable is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Unmovable = Unmovable;
            }
            // to ensure "Online" is required (not null)
            if (Online == null)
            {
                throw new InvalidDataException("Online is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Online = Online;
            }
            // to ensure "Deleted" is required (not null)
            if (Deleted == null)
            {
                throw new InvalidDataException("Deleted is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Deleted = Deleted;
            }
            // to ensure "DeletedAuto" is required (not null)
            if (DeletedAuto == null)
            {
                throw new InvalidDataException("DeletedAuto is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.DeletedAuto = DeletedAuto;
            }
            // to ensure "DeletedDump" is required (not null)
            if (DeletedDump == null)
            {
                throw new InvalidDataException("DeletedDump is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.DeletedDump = DeletedDump;
            }
            // to ensure "UserId" is required (not null)
            if (UserId == null)
            {
                throw new InvalidDataException("UserId is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.UserId = UserId;
            }
            // to ensure "FtpId" is required (not null)
            if (FtpId == null)
            {
                throw new InvalidDataException("FtpId is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FtpId = FtpId;
            }
            // to ensure "DnsId" is required (not null)
            if (DnsId == null)
            {
                throw new InvalidDataException("DnsId is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.DnsId = DnsId;
            }
            // to ensure "IisId" is required (not null)
            if (IisId == null)
            {
                throw new InvalidDataException("IisId is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisId = IisId;
            }
            // to ensure "IisBinding" is required (not null)
            if (IisBinding == null)
            {
                throw new InvalidDataException("IisBinding is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisBinding = IisBinding;
            }
            // to ensure "IisPath" is required (not null)
            if (IisPath == null)
            {
                throw new InvalidDataException("IisPath is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisPath = IisPath;
            }
            // to ensure "IisComments" is required (not null)
            if (IisComments == null)
            {
                throw new InvalidDataException("IisComments is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisComments = IisComments;
            }
            // to ensure "Memo" is required (not null)
            if (Memo == null)
            {
                throw new InvalidDataException("Memo is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Memo = Memo;
            }
            // to ensure "DateReg" is required (not null)
            if (DateReg == null)
            {
                throw new InvalidDataException("DateReg is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.DateReg = DateReg;
            }
            // to ensure "Server" is required (not null)
            if (Server == null)
            {
                throw new InvalidDataException("Server is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.Server = Server;
            }
            // to ensure "ServerBak" is required (not null)
            if (ServerBak == null)
            {
                throw new InvalidDataException("ServerBak is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ServerBak = ServerBak;
            }
            // to ensure "ServerAux" is required (not null)
            if (ServerAux == null)
            {
                throw new InvalidDataException("ServerAux is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ServerAux = ServerAux;
            }
            // to ensure "ServerTransition" is required (not null)
            if (ServerTransition == null)
            {
                throw new InvalidDataException("ServerTransition is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ServerTransition = ServerTransition;
            }
            // to ensure "ServerTransitionDtc" is required (not null)
            if (ServerTransitionDtc == null)
            {
                throw new InvalidDataException("ServerTransitionDtc is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ServerTransitionDtc = ServerTransitionDtc;
            }
            // to ensure "BlockTransfer" is required (not null)
            if (BlockTransfer == null)
            {
                throw new InvalidDataException("BlockTransfer is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BlockTransfer = BlockTransfer;
            }
            // to ensure "ServerChangedTime" is required (not null)
            if (ServerChangedTime == null)
            {
                throw new InvalidDataException("ServerChangedTime is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ServerChangedTime = ServerChangedTime;
            }
            // to ensure "SizeAmount" is required (not null)
            if (SizeAmount == null)
            {
                throw new InvalidDataException("SizeAmount is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeAmount = SizeAmount;
            }
            // to ensure "SizeFileCount" is required (not null)
            if (SizeFileCount == null)
            {
                throw new InvalidDataException("SizeFileCount is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeFileCount = SizeFileCount;
            }
            // to ensure "SizeFileCountLimit" is required (not null)
            if (SizeFileCountLimit == null)
            {
                throw new InvalidDataException("SizeFileCountLimit is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeFileCountLimit = SizeFileCountLimit;
            }
            // to ensure "SizeDate" is required (not null)
            if (SizeDate == null)
            {
                throw new InvalidDataException("SizeDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeDate = SizeDate;
            }
            // to ensure "SizePriorityScan" is required (not null)
            if (SizePriorityScan == null)
            {
                throw new InvalidDataException("SizePriorityScan is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizePriorityScan = SizePriorityScan;
            }
            // to ensure "CopyLogs" is required (not null)
            if (CopyLogs == null)
            {
                throw new InvalidDataException("CopyLogs is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.CopyLogs = CopyLogs;
            }
            // to ensure "ContentComments" is required (not null)
            if (ContentComments == null)
            {
                throw new InvalidDataException("ContentComments is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ContentComments = ContentComments;
            }
            // to ensure "ContentCommentsVerbose" is required (not null)
            if (ContentCommentsVerbose == null)
            {
                throw new InvalidDataException("ContentCommentsVerbose is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ContentCommentsVerbose = ContentCommentsVerbose;
            }
            // to ensure "MetaSaveCount" is required (not null)
            if (MetaSaveCount == null)
            {
                throw new InvalidDataException("MetaSaveCount is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.MetaSaveCount = MetaSaveCount;
            }
            // to ensure "BaseFolder" is required (not null)
            if (BaseFolder == null)
            {
                throw new InvalidDataException("BaseFolder is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BaseFolder = BaseFolder;
            }
            // to ensure "VirtualhostConf" is required (not null)
            if (VirtualhostConf == null)
            {
                throw new InvalidDataException("VirtualhostConf is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.VirtualhostConf = VirtualhostConf;
            }
            // to ensure "VirtualhostServer" is required (not null)
            if (VirtualhostServer == null)
            {
                throw new InvalidDataException("VirtualhostServer is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.VirtualhostServer = VirtualhostServer;
            }
            // to ensure "VirtualhostServerConf" is required (not null)
            if (VirtualhostServerConf == null)
            {
                throw new InvalidDataException("VirtualhostServerConf is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.VirtualhostServerConf = VirtualhostServerConf;
            }
            // to ensure "LiveDayCount" is required (not null)
            if (LiveDayCount == null)
            {
                throw new InvalidDataException("LiveDayCount is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.LiveDayCount = LiveDayCount;
            }
            // to ensure "ScanDate" is required (not null)
            if (ScanDate == null)
            {
                throw new InvalidDataException("ScanDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ScanDate = ScanDate;
            }
            // to ensure "GlobalTransferCount" is required (not null)
            if (GlobalTransferCount == null)
            {
                throw new InvalidDataException("GlobalTransferCount is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.GlobalTransferCount = GlobalTransferCount;
            }
            // to ensure "NetLimitFile" is required (not null)
            if (NetLimitFile == null)
            {
                throw new InvalidDataException("NetLimitFile is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.NetLimitFile = NetLimitFile;
            }
            // to ensure "NetLimitDenyFromIp" is required (not null)
            if (NetLimitDenyFromIp == null)
            {
                throw new InvalidDataException("NetLimitDenyFromIp is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.NetLimitDenyFromIp = NetLimitDenyFromIp;
            }
            // to ensure "NetLimitDenyFromAgent" is required (not null)
            if (NetLimitDenyFromAgent == null)
            {
                throw new InvalidDataException("NetLimitDenyFromAgent is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.NetLimitDenyFromAgent = NetLimitDenyFromAgent;
            }
            // to ensure "ApachePhpPooled" is required (not null)
            if (ApachePhpPooled == null)
            {
                throw new InvalidDataException("ApachePhpPooled is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApachePhpPooled = ApachePhpPooled;
            }
            // to ensure "ApachePhpPooledExt" is required (not null)
            if (ApachePhpPooledExt == null)
            {
                throw new InvalidDataException("ApachePhpPooledExt is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApachePhpPooledExt = ApachePhpPooledExt;
            }
            // to ensure "ApachePhpPooledExtAuto" is required (not null)
            if (ApachePhpPooledExtAuto == null)
            {
                throw new InvalidDataException("ApachePhpPooledExtAuto is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApachePhpPooledExtAuto = ApachePhpPooledExtAuto;
            }
            // to ensure "ApachePhpPool1Only" is required (not null)
            if (ApachePhpPool1Only == null)
            {
                throw new InvalidDataException("ApachePhpPool1Only is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApachePhpPool1Only = ApachePhpPool1Only;
            }
            // to ensure "ApachePhpPool5Only" is required (not null)
            if (ApachePhpPool5Only == null)
            {
                throw new InvalidDataException("ApachePhpPool5Only is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApachePhpPool5Only = ApachePhpPool5Only;
            }
            // to ensure "ApacheSsi" is required (not null)
            if (ApacheSsi == null)
            {
                throw new InvalidDataException("ApacheSsi is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApacheSsi = ApacheSsi;
            }
            // to ensure "BypassSecurity" is required (not null)
            if (BypassSecurity == null)
            {
                throw new InvalidDataException("BypassSecurity is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BypassSecurity = BypassSecurity;
            }
            // to ensure "FlagGenericExec" is required (not null)
            if (FlagGenericExec == null)
            {
                throw new InvalidDataException("FlagGenericExec is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FlagGenericExec = FlagGenericExec;
            }
            // to ensure "FlagNoWww" is required (not null)
            if (FlagNoWww == null)
            {
                throw new InvalidDataException("FlagNoWww is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FlagNoWww = FlagNoWww;
            }
            // to ensure "BaseFolderSuffix" is required (not null)
            if (BaseFolderSuffix == null)
            {
                throw new InvalidDataException("BaseFolderSuffix is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BaseFolderSuffix = BaseFolderSuffix;
            }
            // to ensure "FeedbackSpeed" is required (not null)
            if (FeedbackSpeed == null)
            {
                throw new InvalidDataException("FeedbackSpeed is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FeedbackSpeed = FeedbackSpeed;
            }
            // to ensure "FeedbackSpeedDtc" is required (not null)
            if (FeedbackSpeedDtc == null)
            {
                throw new InvalidDataException("FeedbackSpeedDtc is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FeedbackSpeedDtc = FeedbackSpeedDtc;
            }
            // to ensure "FeedbackSpeedFeedback" is required (not null)
            if (FeedbackSpeedFeedback == null)
            {
                throw new InvalidDataException("FeedbackSpeedFeedback is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FeedbackSpeedFeedback = FeedbackSpeedFeedback;
            }
            // to ensure "UnixPathOnWindows" is required (not null)
            if (UnixPathOnWindows == null)
            {
                throw new InvalidDataException("UnixPathOnWindows is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.UnixPathOnWindows = UnixPathOnWindows;
            }
            // to ensure "FtpIpfilter" is required (not null)
            if (FtpIpfilter == null)
            {
                throw new InvalidDataException("FtpIpfilter is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FtpIpfilter = FtpIpfilter;
            }
            // to ensure "SshIpfilter" is required (not null)
            if (SshIpfilter == null)
            {
                throw new InvalidDataException("SshIpfilter is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SshIpfilter = SshIpfilter;
            }
            // to ensure "L3dAuto" is required (not null)
            if (L3dAuto == null)
            {
                throw new InvalidDataException("L3dAuto is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.L3dAuto = L3dAuto;
            }
            // to ensure "AwstatsPrimaryDomain" is required (not null)
            if (AwstatsPrimaryDomain == null)
            {
                throw new InvalidDataException("AwstatsPrimaryDomain is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AwstatsPrimaryDomain = AwstatsPrimaryDomain;
            }
            // to ensure "SharepointMode" is required (not null)
            if (SharepointMode == null)
            {
                throw new InvalidDataException("SharepointMode is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SharepointMode = SharepointMode;
            }
            // to ensure "SharepointModePending" is required (not null)
            if (SharepointModePending == null)
            {
                throw new InvalidDataException("SharepointModePending is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SharepointModePending = SharepointModePending;
            }
            // to ensure "ApacheGenericPoolPort" is required (not null)
            if (ApacheGenericPoolPort == null)
            {
                throw new InvalidDataException("ApacheGenericPoolPort is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ApacheGenericPoolPort = ApacheGenericPoolPort;
            }
            // to ensure "MongrelEnvironment" is required (not null)
            if (MongrelEnvironment == null)
            {
                throw new InvalidDataException("MongrelEnvironment is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.MongrelEnvironment = MongrelEnvironment;
            }
            // to ensure "FlagFree" is required (not null)
            if (FlagFree == null)
            {
                throw new InvalidDataException("FlagFree is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FlagFree = FlagFree;
            }
            // to ensure "RtmScanDate" is required (not null)
            if (RtmScanDate == null)
            {
                throw new InvalidDataException("RtmScanDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.RtmScanDate = RtmScanDate;
            }
            // to ensure "AnalyzeAnalog" is required (not null)
            if (AnalyzeAnalog == null)
            {
                throw new InvalidDataException("AnalyzeAnalog is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AnalyzeAnalog = AnalyzeAnalog;
            }
            // to ensure "CpuDetailsEnabled" is required (not null)
            if (CpuDetailsEnabled == null)
            {
                throw new InvalidDataException("CpuDetailsEnabled is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.CpuDetailsEnabled = CpuDetailsEnabled;
            }
            // to ensure "ContentModeratedStatus" is required (not null)
            if (ContentModeratedStatus == null)
            {
                throw new InvalidDataException("ContentModeratedStatus is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ContentModeratedStatus = ContentModeratedStatus;
            }
            // to ensure "ContentModeratedDate" is required (not null)
            if (ContentModeratedDate == null)
            {
                throw new InvalidDataException("ContentModeratedDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ContentModeratedDate = ContentModeratedDate;
            }
            // to ensure "HttpFrontendIp" is required (not null)
            if (HttpFrontendIp == null)
            {
                throw new InvalidDataException("HttpFrontendIp is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.HttpFrontendIp = HttpFrontendIp;
            }
            // to ensure "HttpFrontendIpTransition" is required (not null)
            if (HttpFrontendIpTransition == null)
            {
                throw new InvalidDataException("HttpFrontendIpTransition is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.HttpFrontendIpTransition = HttpFrontendIpTransition;
            }
            // to ensure "CpuLimitExceededDate" is required (not null)
            if (CpuLimitExceededDate == null)
            {
                throw new InvalidDataException("CpuLimitExceededDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.CpuLimitExceededDate = CpuLimitExceededDate;
            }
            // to ensure "AufsTemplate" is required (not null)
            if (AufsTemplate == null)
            {
                throw new InvalidDataException("AufsTemplate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AufsTemplate = AufsTemplate;
            }
            // to ensure "OptionsAutolimit" is required (not null)
            if (OptionsAutolimit == null)
            {
                throw new InvalidDataException("OptionsAutolimit is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.OptionsAutolimit = OptionsAutolimit;
            }
            // to ensure "IisCreationCommands" is required (not null)
            if (IisCreationCommands == null)
            {
                throw new InvalidDataException("IisCreationCommands is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisCreationCommands = IisCreationCommands;
            }
            // to ensure "IisCreationCommandsUnix" is required (not null)
            if (IisCreationCommandsUnix == null)
            {
                throw new InvalidDataException("IisCreationCommandsUnix is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.IisCreationCommandsUnix = IisCreationCommandsUnix;
            }
            // to ensure "ThumbDate" is required (not null)
            if (ThumbDate == null)
            {
                throw new InvalidDataException("ThumbDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ThumbDate = ThumbDate;
            }
            // to ensure "ThumbFailed" is required (not null)
            if (ThumbFailed == null)
            {
                throw new InvalidDataException("ThumbFailed is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.ThumbFailed = ThumbFailed;
            }
            // to ensure "BackupStatDate" is required (not null)
            if (BackupStatDate == null)
            {
                throw new InvalidDataException("BackupStatDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupStatDate = BackupStatDate;
            }
            // to ensure "BackupDate" is required (not null)
            if (BackupDate == null)
            {
                throw new InvalidDataException("BackupDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupDate = BackupDate;
            }
            // to ensure "DetectedPackages" is required (not null)
            if (DetectedPackages == null)
            {
                throw new InvalidDataException("DetectedPackages is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.DetectedPackages = DetectedPackages;
            }
            // to ensure "StatSitePower" is required (not null)
            if (StatSitePower == null)
            {
                throw new InvalidDataException("StatSitePower is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.StatSitePower = StatSitePower;
            }
            // to ensure "SmtpFrom" is required (not null)
            if (SmtpFrom == null)
            {
                throw new InvalidDataException("SmtpFrom is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SmtpFrom = SmtpFrom;
            }
            // to ensure "SuperBackupDate" is required (not null)
            if (SuperBackupDate == null)
            {
                throw new InvalidDataException("SuperBackupDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SuperBackupDate = SuperBackupDate;
            }
            // to ensure "BackupDeltaStatDate" is required (not null)
            if (BackupDeltaStatDate == null)
            {
                throw new InvalidDataException("BackupDeltaStatDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupDeltaStatDate = BackupDeltaStatDate;
            }
            // to ensure "BackupDeltaDate" is required (not null)
            if (BackupDeltaDate == null)
            {
                throw new InvalidDataException("BackupDeltaDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupDeltaDate = BackupDeltaDate;
            }
            // to ensure "BackupDeltaDesc" is required (not null)
            if (BackupDeltaDesc == null)
            {
                throw new InvalidDataException("BackupDeltaDesc is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupDeltaDesc = BackupDeltaDesc;
            }
            // to ensure "AltDocrootServer" is required (not null)
            if (AltDocrootServer == null)
            {
                throw new InvalidDataException("AltDocrootServer is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootServer = AltDocrootServer;
            }
            // to ensure "AltDocrootPath" is required (not null)
            if (AltDocrootPath == null)
            {
                throw new InvalidDataException("AltDocrootPath is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootPath = AltDocrootPath;
            }
            // to ensure "AltDocrootStatus" is required (not null)
            if (AltDocrootStatus == null)
            {
                throw new InvalidDataException("AltDocrootStatus is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootStatus = AltDocrootStatus;
            }
            // to ensure "AltDocrootStatusCnt" is required (not null)
            if (AltDocrootStatusCnt == null)
            {
                throw new InvalidDataException("AltDocrootStatusCnt is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootStatusCnt = AltDocrootStatusCnt;
            }
            // to ensure "AltDocrootStatusDate" is required (not null)
            if (AltDocrootStatusDate == null)
            {
                throw new InvalidDataException("AltDocrootStatusDate is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootStatusDate = AltDocrootStatusDate;
            }
            // to ensure "BindDtc" is required (not null)
            if (BindDtc == null)
            {
                throw new InvalidDataException("BindDtc is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BindDtc = BindDtc;
            }
            // to ensure "BackupSpecialMode" is required (not null)
            if (BackupSpecialMode == null)
            {
                throw new InvalidDataException("BackupSpecialMode is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.BackupSpecialMode = BackupSpecialMode;
            }
            // to ensure "SizeCheckProblem" is required (not null)
            if (SizeCheckProblem == null)
            {
                throw new InvalidDataException("SizeCheckProblem is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeCheckProblem = SizeCheckProblem;
            }
            // to ensure "WpbDomain" is required (not null)
            if (WpbDomain == null)
            {
                throw new InvalidDataException("WpbDomain is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.WpbDomain = WpbDomain;
            }
            // to ensure "WpbUuid" is required (not null)
            if (WpbUuid == null)
            {
                throw new InvalidDataException("WpbUuid is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.WpbUuid = WpbUuid;
            }
            // to ensure "WpbStatus" is required (not null)
            if (WpbStatus == null)
            {
                throw new InvalidDataException("WpbStatus is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.WpbStatus = WpbStatus;
            }
            // to ensure "AdminProtection" is required (not null)
            if (AdminProtection == null)
            {
                throw new InvalidDataException("AdminProtection is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AdminProtection = AdminProtection;
            }
            // to ensure "SizeComments" is required (not null)
            if (SizeComments == null)
            {
                throw new InvalidDataException("SizeComments is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.SizeComments = SizeComments;
            }
            // to ensure "AltDocrootSsdReq" is required (not null)
            if (AltDocrootSsdReq == null)
            {
                throw new InvalidDataException("AltDocrootSsdReq is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.AltDocrootSsdReq = AltDocrootSsdReq;
            }
            // to ensure "MailLimit" is required (not null)
            if (MailLimit == null)
            {
                throw new InvalidDataException("MailLimit is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.MailLimit = MailLimit;
            }
            // to ensure "MailAccept" is required (not null)
            if (MailAccept == null)
            {
                throw new InvalidDataException("MailAccept is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.MailAccept = MailAccept;
            }
            // to ensure "MailDrop" is required (not null)
            if (MailDrop == null)
            {
                throw new InvalidDataException("MailDrop is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.MailDrop = MailDrop;
            }
            // to ensure "FtpName" is required (not null)
            if (FtpName == null)
            {
                throw new InvalidDataException("FtpName is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FtpName = FtpName;
            }
            // to ensure "FtpPwd" is required (not null)
            if (FtpPwd == null)
            {
                throw new InvalidDataException("FtpPwd is a required property for InlineResponse20014 and cannot be null");
            }
            else
            {
                this.FtpPwd = FtpPwd;
            }
            
        }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? Id { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Status { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Unmovable { get; set; }

        /// <summary>
        /// Включен (активен), если true.
        /// </summary>
        /// <value>Включен (активен), если true.</value>
        public string Online { get; set; }

        /// <summary>
        /// Удален, если true. Данные могут сохраняться.
        /// </summary>
        /// <value>Удален, если true. Данные могут сохраняться.</value>
        public string Deleted { get; set; }

        /// <summary>
        /// Удален, если true. Данные могут сохраняться.
        /// </summary>
        /// <value>Удален, если true. Данные могут сохраняться.</value>
        public string DeletedAuto { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string DeletedDump { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string UserId { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FtpId { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string DnsId { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string IisId { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string IisBinding { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string IisPath { get; set; }

        /// <summary>
        /// Уникальное строковое имя сайта (ID).
        /// </summary>
        /// <value>Уникальное строковое имя сайта (ID).</value>
        public string IisComments { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Memo { get; set; }

        /// <summary>
        /// Дата создания.
        /// </summary>
        /// <value>Дата создания.</value>
        public string DateReg { get; set; }

        /// <summary>
        /// Тип веб-сервера.
        /// </summary>
        /// <value>Тип веб-сервера.</value>
        public string Server { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ServerBak { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ServerAux { get; set; }

        /// <summary>
        /// Тип сервера недавно изменялся, если true.
        /// </summary>
        /// <value>Тип сервера недавно изменялся, если true.</value>
        public string ServerTransition { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ServerTransitionDtc { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BlockTransfer { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ServerChangedTime { get; set; }

        /// <summary>
        /// Размер веб-сайта - объем (Кб).
        /// </summary>
        /// <value>Размер веб-сайта - объем (Кб).</value>
        public string SizeAmount { get; set; }

        /// <summary>
        /// Размер веб-сайта - кол-во файлов.
        /// </summary>
        /// <value>Размер веб-сайта - кол-во файлов.</value>
        public string SizeFileCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SizeFileCountLimit { get; set; }

        /// <summary>
        /// Размер веб-сайта - дата замера.
        /// </summary>
        /// <value>Размер веб-сайта - дата замера.</value>
        public string SizeDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SizePriorityScan { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string CopyLogs { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ContentComments { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ContentCommentsVerbose { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string MetaSaveCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BaseFolder { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string VirtualhostConf { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string VirtualhostServer { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string VirtualhostServerConf { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string LiveDayCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ScanDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string GlobalTransferCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string NetLimitFile { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string NetLimitDenyFromIp { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string NetLimitDenyFromAgent { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApachePhpPooled { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApachePhpPooledExt { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApachePhpPooledExtAuto { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApachePhpPool1Only { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApachePhpPool5Only { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApacheSsi { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BypassSecurity { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FlagGenericExec { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FlagNoWww { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BaseFolderSuffix { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FeedbackSpeed { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FeedbackSpeedDtc { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FeedbackSpeedFeedback { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string UnixPathOnWindows { get; set; }

        /// <summary>
        /// Ограничение по IP адресам - FTP доступ.
        /// </summary>
        /// <value>Ограничение по IP адресам - FTP доступ.</value>
        public string FtpIpfilter { get; set; }

        /// <summary>
        /// Ограничение по IP адресам - SSH доступ.
        /// </summary>
        /// <value>Ограничение по IP адресам - SSH доступ.</value>
        public string SshIpfilter { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string L3dAuto { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AwstatsPrimaryDomain { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SharepointMode { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SharepointModePending { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ApacheGenericPoolPort { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string MongrelEnvironment { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string FlagFree { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string RtmScanDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AnalyzeAnalog { get; set; }

        /// <summary>
        /// Включен режим предоставления детализации процессорной нагрузки.
        /// </summary>
        /// <value>Включен режим предоставления детализации процессорной нагрузки.</value>
        public string CpuDetailsEnabled { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ContentModeratedStatus { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ContentModeratedDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string HttpFrontendIp { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string HttpFrontendIpTransition { get; set; }

        /// <summary>
        /// Дата последнего превышения процессорной нагрузки.
        /// </summary>
        /// <value>Дата последнего превышения процессорной нагрузки.</value>
        public string CpuLimitExceededDate { get; set; }

        /// <summary>
        /// Признак сайта-конструктора.
        /// </summary>
        /// <value>Признак сайта-конструктора.</value>
        public string AufsTemplate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string OptionsAutolimit { get; set; }

        /// <summary>
        /// Версия ASP.NET, если отлична от 2.0.
        /// </summary>
        /// <value>Версия ASP.NET, если отлична от 2.0.</value>
        public string IisCreationCommands { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string IisCreationCommandsUnix { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ThumbDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ThumbFailed { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BackupStatDate { get; set; }

        /// <summary>
        /// Дата пофайловой резервной копии.
        /// </summary>
        /// <value>Дата пофайловой резервной копии.</value>
        public string BackupDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string DetectedPackages { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string StatSitePower { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SmtpFrom { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SuperBackupDate { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BackupDeltaStatDate { get; set; }

        /// <summary>
        /// Дата архивной резервной копии.
        /// </summary>
        /// <value>Дата архивной резервной копии.</value>
        public string BackupDeltaDate { get; set; }

        /// <summary>
        /// Содержимое архивной резервной копии.
        /// </summary>
        /// <value>Содержимое архивной резервной копии.</value>
        public string BackupDeltaDesc { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootServer { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootPath { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootStatus { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootStatusCnt { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootStatusDate { get; set; }

        /// <summary>
        /// Последнее изменение привязок доменов для сайта.
        /// </summary>
        /// <value>Последнее изменение привязок доменов для сайта.</value>
        public string BindDtc { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string BackupSpecialMode { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SizeCheckProblem { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string WpbDomain { get; set; }

        /// <summary>
        /// Для сайта включен конструктор Parallels WPB.
        /// </summary>
        /// <value>Для сайта включен конструктор Parallels WPB.</value>
        public string WpbUuid { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string WpbStatus { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AdminProtection { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SizeComments { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string AltDocrootSsdReq { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string MailLimit { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string MailAccept { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string MailDrop { get; set; }

        /// <summary>
        /// FTP/SSH/SCP/SFTP логин.
        /// </summary>
        /// <value>FTP/SSH/SCP/SFTP логин.</value>
        public string FtpName { get; set; }

        /// <summary>
        /// FTP/SSH/SCP/SFTP пароль.
        /// </summary>
        /// <value>FTP/SSH/SCP/SFTP пароль.</value>
        public string FtpPwd { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse20014 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Status: ").Append(Status).Append("\n");
sb.Append("  Unmovable: ").Append(Unmovable).Append("\n");
sb.Append("  Online: ").Append(Online).Append("\n");
sb.Append("  Deleted: ").Append(Deleted).Append("\n");
sb.Append("  DeletedAuto: ").Append(DeletedAuto).Append("\n");
sb.Append("  DeletedDump: ").Append(DeletedDump).Append("\n");
sb.Append("  UserId: ").Append(UserId).Append("\n");
sb.Append("  FtpId: ").Append(FtpId).Append("\n");
sb.Append("  DnsId: ").Append(DnsId).Append("\n");
sb.Append("  IisId: ").Append(IisId).Append("\n");
sb.Append("  IisBinding: ").Append(IisBinding).Append("\n");
sb.Append("  IisPath: ").Append(IisPath).Append("\n");
sb.Append("  IisComments: ").Append(IisComments).Append("\n");
sb.Append("  Memo: ").Append(Memo).Append("\n");
sb.Append("  DateReg: ").Append(DateReg).Append("\n");
sb.Append("  Server: ").Append(Server).Append("\n");
sb.Append("  ServerBak: ").Append(ServerBak).Append("\n");
sb.Append("  ServerAux: ").Append(ServerAux).Append("\n");
sb.Append("  ServerTransition: ").Append(ServerTransition).Append("\n");
sb.Append("  ServerTransitionDtc: ").Append(ServerTransitionDtc).Append("\n");
sb.Append("  BlockTransfer: ").Append(BlockTransfer).Append("\n");
sb.Append("  ServerChangedTime: ").Append(ServerChangedTime).Append("\n");
sb.Append("  SizeAmount: ").Append(SizeAmount).Append("\n");
sb.Append("  SizeFileCount: ").Append(SizeFileCount).Append("\n");
sb.Append("  SizeFileCountLimit: ").Append(SizeFileCountLimit).Append("\n");
sb.Append("  SizeDate: ").Append(SizeDate).Append("\n");
sb.Append("  SizePriorityScan: ").Append(SizePriorityScan).Append("\n");
sb.Append("  CopyLogs: ").Append(CopyLogs).Append("\n");
sb.Append("  ContentComments: ").Append(ContentComments).Append("\n");
sb.Append("  ContentCommentsVerbose: ").Append(ContentCommentsVerbose).Append("\n");
sb.Append("  MetaSaveCount: ").Append(MetaSaveCount).Append("\n");
sb.Append("  BaseFolder: ").Append(BaseFolder).Append("\n");
sb.Append("  VirtualhostConf: ").Append(VirtualhostConf).Append("\n");
sb.Append("  VirtualhostServer: ").Append(VirtualhostServer).Append("\n");
sb.Append("  VirtualhostServerConf: ").Append(VirtualhostServerConf).Append("\n");
sb.Append("  LiveDayCount: ").Append(LiveDayCount).Append("\n");
sb.Append("  ScanDate: ").Append(ScanDate).Append("\n");
sb.Append("  GlobalTransferCount: ").Append(GlobalTransferCount).Append("\n");
sb.Append("  NetLimitFile: ").Append(NetLimitFile).Append("\n");
sb.Append("  NetLimitDenyFromIp: ").Append(NetLimitDenyFromIp).Append("\n");
sb.Append("  NetLimitDenyFromAgent: ").Append(NetLimitDenyFromAgent).Append("\n");
sb.Append("  ApachePhpPooled: ").Append(ApachePhpPooled).Append("\n");
sb.Append("  ApachePhpPooledExt: ").Append(ApachePhpPooledExt).Append("\n");
sb.Append("  ApachePhpPooledExtAuto: ").Append(ApachePhpPooledExtAuto).Append("\n");
sb.Append("  ApachePhpPool1Only: ").Append(ApachePhpPool1Only).Append("\n");
sb.Append("  ApachePhpPool5Only: ").Append(ApachePhpPool5Only).Append("\n");
sb.Append("  ApacheSsi: ").Append(ApacheSsi).Append("\n");
sb.Append("  BypassSecurity: ").Append(BypassSecurity).Append("\n");
sb.Append("  FlagGenericExec: ").Append(FlagGenericExec).Append("\n");
sb.Append("  FlagNoWww: ").Append(FlagNoWww).Append("\n");
sb.Append("  BaseFolderSuffix: ").Append(BaseFolderSuffix).Append("\n");
sb.Append("  FeedbackSpeed: ").Append(FeedbackSpeed).Append("\n");
sb.Append("  FeedbackSpeedDtc: ").Append(FeedbackSpeedDtc).Append("\n");
sb.Append("  FeedbackSpeedFeedback: ").Append(FeedbackSpeedFeedback).Append("\n");
sb.Append("  UnixPathOnWindows: ").Append(UnixPathOnWindows).Append("\n");
sb.Append("  FtpIpfilter: ").Append(FtpIpfilter).Append("\n");
sb.Append("  SshIpfilter: ").Append(SshIpfilter).Append("\n");
sb.Append("  L3dAuto: ").Append(L3dAuto).Append("\n");
sb.Append("  AwstatsPrimaryDomain: ").Append(AwstatsPrimaryDomain).Append("\n");
sb.Append("  SharepointMode: ").Append(SharepointMode).Append("\n");
sb.Append("  SharepointModePending: ").Append(SharepointModePending).Append("\n");
sb.Append("  ApacheGenericPoolPort: ").Append(ApacheGenericPoolPort).Append("\n");
sb.Append("  MongrelEnvironment: ").Append(MongrelEnvironment).Append("\n");
sb.Append("  FlagFree: ").Append(FlagFree).Append("\n");
sb.Append("  RtmScanDate: ").Append(RtmScanDate).Append("\n");
sb.Append("  AnalyzeAnalog: ").Append(AnalyzeAnalog).Append("\n");
sb.Append("  CpuDetailsEnabled: ").Append(CpuDetailsEnabled).Append("\n");
sb.Append("  ContentModeratedStatus: ").Append(ContentModeratedStatus).Append("\n");
sb.Append("  ContentModeratedDate: ").Append(ContentModeratedDate).Append("\n");
sb.Append("  HttpFrontendIp: ").Append(HttpFrontendIp).Append("\n");
sb.Append("  HttpFrontendIpTransition: ").Append(HttpFrontendIpTransition).Append("\n");
sb.Append("  CpuLimitExceededDate: ").Append(CpuLimitExceededDate).Append("\n");
sb.Append("  AufsTemplate: ").Append(AufsTemplate).Append("\n");
sb.Append("  OptionsAutolimit: ").Append(OptionsAutolimit).Append("\n");
sb.Append("  IisCreationCommands: ").Append(IisCreationCommands).Append("\n");
sb.Append("  IisCreationCommandsUnix: ").Append(IisCreationCommandsUnix).Append("\n");
sb.Append("  ThumbDate: ").Append(ThumbDate).Append("\n");
sb.Append("  ThumbFailed: ").Append(ThumbFailed).Append("\n");
sb.Append("  BackupStatDate: ").Append(BackupStatDate).Append("\n");
sb.Append("  BackupDate: ").Append(BackupDate).Append("\n");
sb.Append("  DetectedPackages: ").Append(DetectedPackages).Append("\n");
sb.Append("  StatSitePower: ").Append(StatSitePower).Append("\n");
sb.Append("  SmtpFrom: ").Append(SmtpFrom).Append("\n");
sb.Append("  SuperBackupDate: ").Append(SuperBackupDate).Append("\n");
sb.Append("  BackupDeltaStatDate: ").Append(BackupDeltaStatDate).Append("\n");
sb.Append("  BackupDeltaDate: ").Append(BackupDeltaDate).Append("\n");
sb.Append("  BackupDeltaDesc: ").Append(BackupDeltaDesc).Append("\n");
sb.Append("  AltDocrootServer: ").Append(AltDocrootServer).Append("\n");
sb.Append("  AltDocrootPath: ").Append(AltDocrootPath).Append("\n");
sb.Append("  AltDocrootStatus: ").Append(AltDocrootStatus).Append("\n");
sb.Append("  AltDocrootStatusCnt: ").Append(AltDocrootStatusCnt).Append("\n");
sb.Append("  AltDocrootStatusDate: ").Append(AltDocrootStatusDate).Append("\n");
sb.Append("  BindDtc: ").Append(BindDtc).Append("\n");
sb.Append("  BackupSpecialMode: ").Append(BackupSpecialMode).Append("\n");
sb.Append("  SizeCheckProblem: ").Append(SizeCheckProblem).Append("\n");
sb.Append("  WpbDomain: ").Append(WpbDomain).Append("\n");
sb.Append("  WpbUuid: ").Append(WpbUuid).Append("\n");
sb.Append("  WpbStatus: ").Append(WpbStatus).Append("\n");
sb.Append("  AdminProtection: ").Append(AdminProtection).Append("\n");
sb.Append("  SizeComments: ").Append(SizeComments).Append("\n");
sb.Append("  AltDocrootSsdReq: ").Append(AltDocrootSsdReq).Append("\n");
sb.Append("  MailLimit: ").Append(MailLimit).Append("\n");
sb.Append("  MailAccept: ").Append(MailAccept).Append("\n");
sb.Append("  MailDrop: ").Append(MailDrop).Append("\n");
sb.Append("  FtpName: ").Append(FtpName).Append("\n");
sb.Append("  FtpPwd: ").Append(FtpPwd).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse20014)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse20014 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse20014 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse20014 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.Unmovable == other.Unmovable ||
                    this.Unmovable != null &&
                    this.Unmovable.Equals(other.Unmovable)
                ) && 
                (
                    this.Online == other.Online ||
                    this.Online != null &&
                    this.Online.Equals(other.Online)
                ) && 
                (
                    this.Deleted == other.Deleted ||
                    this.Deleted != null &&
                    this.Deleted.Equals(other.Deleted)
                ) && 
                (
                    this.DeletedAuto == other.DeletedAuto ||
                    this.DeletedAuto != null &&
                    this.DeletedAuto.Equals(other.DeletedAuto)
                ) && 
                (
                    this.DeletedDump == other.DeletedDump ||
                    this.DeletedDump != null &&
                    this.DeletedDump.Equals(other.DeletedDump)
                ) && 
                (
                    this.UserId == other.UserId ||
                    this.UserId != null &&
                    this.UserId.Equals(other.UserId)
                ) && 
                (
                    this.FtpId == other.FtpId ||
                    this.FtpId != null &&
                    this.FtpId.Equals(other.FtpId)
                ) && 
                (
                    this.DnsId == other.DnsId ||
                    this.DnsId != null &&
                    this.DnsId.Equals(other.DnsId)
                ) && 
                (
                    this.IisId == other.IisId ||
                    this.IisId != null &&
                    this.IisId.Equals(other.IisId)
                ) && 
                (
                    this.IisBinding == other.IisBinding ||
                    this.IisBinding != null &&
                    this.IisBinding.Equals(other.IisBinding)
                ) && 
                (
                    this.IisPath == other.IisPath ||
                    this.IisPath != null &&
                    this.IisPath.Equals(other.IisPath)
                ) && 
                (
                    this.IisComments == other.IisComments ||
                    this.IisComments != null &&
                    this.IisComments.Equals(other.IisComments)
                ) && 
                (
                    this.Memo == other.Memo ||
                    this.Memo != null &&
                    this.Memo.Equals(other.Memo)
                ) && 
                (
                    this.DateReg == other.DateReg ||
                    this.DateReg != null &&
                    this.DateReg.Equals(other.DateReg)
                ) && 
                (
                    this.Server == other.Server ||
                    this.Server != null &&
                    this.Server.Equals(other.Server)
                ) && 
                (
                    this.ServerBak == other.ServerBak ||
                    this.ServerBak != null &&
                    this.ServerBak.Equals(other.ServerBak)
                ) && 
                (
                    this.ServerAux == other.ServerAux ||
                    this.ServerAux != null &&
                    this.ServerAux.Equals(other.ServerAux)
                ) && 
                (
                    this.ServerTransition == other.ServerTransition ||
                    this.ServerTransition != null &&
                    this.ServerTransition.Equals(other.ServerTransition)
                ) && 
                (
                    this.ServerTransitionDtc == other.ServerTransitionDtc ||
                    this.ServerTransitionDtc != null &&
                    this.ServerTransitionDtc.Equals(other.ServerTransitionDtc)
                ) && 
                (
                    this.BlockTransfer == other.BlockTransfer ||
                    this.BlockTransfer != null &&
                    this.BlockTransfer.Equals(other.BlockTransfer)
                ) && 
                (
                    this.ServerChangedTime == other.ServerChangedTime ||
                    this.ServerChangedTime != null &&
                    this.ServerChangedTime.Equals(other.ServerChangedTime)
                ) && 
                (
                    this.SizeAmount == other.SizeAmount ||
                    this.SizeAmount != null &&
                    this.SizeAmount.Equals(other.SizeAmount)
                ) && 
                (
                    this.SizeFileCount == other.SizeFileCount ||
                    this.SizeFileCount != null &&
                    this.SizeFileCount.Equals(other.SizeFileCount)
                ) && 
                (
                    this.SizeFileCountLimit == other.SizeFileCountLimit ||
                    this.SizeFileCountLimit != null &&
                    this.SizeFileCountLimit.Equals(other.SizeFileCountLimit)
                ) && 
                (
                    this.SizeDate == other.SizeDate ||
                    this.SizeDate != null &&
                    this.SizeDate.Equals(other.SizeDate)
                ) && 
                (
                    this.SizePriorityScan == other.SizePriorityScan ||
                    this.SizePriorityScan != null &&
                    this.SizePriorityScan.Equals(other.SizePriorityScan)
                ) && 
                (
                    this.CopyLogs == other.CopyLogs ||
                    this.CopyLogs != null &&
                    this.CopyLogs.Equals(other.CopyLogs)
                ) && 
                (
                    this.ContentComments == other.ContentComments ||
                    this.ContentComments != null &&
                    this.ContentComments.Equals(other.ContentComments)
                ) && 
                (
                    this.ContentCommentsVerbose == other.ContentCommentsVerbose ||
                    this.ContentCommentsVerbose != null &&
                    this.ContentCommentsVerbose.Equals(other.ContentCommentsVerbose)
                ) && 
                (
                    this.MetaSaveCount == other.MetaSaveCount ||
                    this.MetaSaveCount != null &&
                    this.MetaSaveCount.Equals(other.MetaSaveCount)
                ) && 
                (
                    this.BaseFolder == other.BaseFolder ||
                    this.BaseFolder != null &&
                    this.BaseFolder.Equals(other.BaseFolder)
                ) && 
                (
                    this.VirtualhostConf == other.VirtualhostConf ||
                    this.VirtualhostConf != null &&
                    this.VirtualhostConf.Equals(other.VirtualhostConf)
                ) && 
                (
                    this.VirtualhostServer == other.VirtualhostServer ||
                    this.VirtualhostServer != null &&
                    this.VirtualhostServer.Equals(other.VirtualhostServer)
                ) && 
                (
                    this.VirtualhostServerConf == other.VirtualhostServerConf ||
                    this.VirtualhostServerConf != null &&
                    this.VirtualhostServerConf.Equals(other.VirtualhostServerConf)
                ) && 
                (
                    this.LiveDayCount == other.LiveDayCount ||
                    this.LiveDayCount != null &&
                    this.LiveDayCount.Equals(other.LiveDayCount)
                ) && 
                (
                    this.ScanDate == other.ScanDate ||
                    this.ScanDate != null &&
                    this.ScanDate.Equals(other.ScanDate)
                ) && 
                (
                    this.GlobalTransferCount == other.GlobalTransferCount ||
                    this.GlobalTransferCount != null &&
                    this.GlobalTransferCount.Equals(other.GlobalTransferCount)
                ) && 
                (
                    this.NetLimitFile == other.NetLimitFile ||
                    this.NetLimitFile != null &&
                    this.NetLimitFile.Equals(other.NetLimitFile)
                ) && 
                (
                    this.NetLimitDenyFromIp == other.NetLimitDenyFromIp ||
                    this.NetLimitDenyFromIp != null &&
                    this.NetLimitDenyFromIp.Equals(other.NetLimitDenyFromIp)
                ) && 
                (
                    this.NetLimitDenyFromAgent == other.NetLimitDenyFromAgent ||
                    this.NetLimitDenyFromAgent != null &&
                    this.NetLimitDenyFromAgent.Equals(other.NetLimitDenyFromAgent)
                ) && 
                (
                    this.ApachePhpPooled == other.ApachePhpPooled ||
                    this.ApachePhpPooled != null &&
                    this.ApachePhpPooled.Equals(other.ApachePhpPooled)
                ) && 
                (
                    this.ApachePhpPooledExt == other.ApachePhpPooledExt ||
                    this.ApachePhpPooledExt != null &&
                    this.ApachePhpPooledExt.Equals(other.ApachePhpPooledExt)
                ) && 
                (
                    this.ApachePhpPooledExtAuto == other.ApachePhpPooledExtAuto ||
                    this.ApachePhpPooledExtAuto != null &&
                    this.ApachePhpPooledExtAuto.Equals(other.ApachePhpPooledExtAuto)
                ) && 
                (
                    this.ApachePhpPool1Only == other.ApachePhpPool1Only ||
                    this.ApachePhpPool1Only != null &&
                    this.ApachePhpPool1Only.Equals(other.ApachePhpPool1Only)
                ) && 
                (
                    this.ApachePhpPool5Only == other.ApachePhpPool5Only ||
                    this.ApachePhpPool5Only != null &&
                    this.ApachePhpPool5Only.Equals(other.ApachePhpPool5Only)
                ) && 
                (
                    this.ApacheSsi == other.ApacheSsi ||
                    this.ApacheSsi != null &&
                    this.ApacheSsi.Equals(other.ApacheSsi)
                ) && 
                (
                    this.BypassSecurity == other.BypassSecurity ||
                    this.BypassSecurity != null &&
                    this.BypassSecurity.Equals(other.BypassSecurity)
                ) && 
                (
                    this.FlagGenericExec == other.FlagGenericExec ||
                    this.FlagGenericExec != null &&
                    this.FlagGenericExec.Equals(other.FlagGenericExec)
                ) && 
                (
                    this.FlagNoWww == other.FlagNoWww ||
                    this.FlagNoWww != null &&
                    this.FlagNoWww.Equals(other.FlagNoWww)
                ) && 
                (
                    this.BaseFolderSuffix == other.BaseFolderSuffix ||
                    this.BaseFolderSuffix != null &&
                    this.BaseFolderSuffix.Equals(other.BaseFolderSuffix)
                ) && 
                (
                    this.FeedbackSpeed == other.FeedbackSpeed ||
                    this.FeedbackSpeed != null &&
                    this.FeedbackSpeed.Equals(other.FeedbackSpeed)
                ) && 
                (
                    this.FeedbackSpeedDtc == other.FeedbackSpeedDtc ||
                    this.FeedbackSpeedDtc != null &&
                    this.FeedbackSpeedDtc.Equals(other.FeedbackSpeedDtc)
                ) && 
                (
                    this.FeedbackSpeedFeedback == other.FeedbackSpeedFeedback ||
                    this.FeedbackSpeedFeedback != null &&
                    this.FeedbackSpeedFeedback.Equals(other.FeedbackSpeedFeedback)
                ) && 
                (
                    this.UnixPathOnWindows == other.UnixPathOnWindows ||
                    this.UnixPathOnWindows != null &&
                    this.UnixPathOnWindows.Equals(other.UnixPathOnWindows)
                ) && 
                (
                    this.FtpIpfilter == other.FtpIpfilter ||
                    this.FtpIpfilter != null &&
                    this.FtpIpfilter.Equals(other.FtpIpfilter)
                ) && 
                (
                    this.SshIpfilter == other.SshIpfilter ||
                    this.SshIpfilter != null &&
                    this.SshIpfilter.Equals(other.SshIpfilter)
                ) && 
                (
                    this.L3dAuto == other.L3dAuto ||
                    this.L3dAuto != null &&
                    this.L3dAuto.Equals(other.L3dAuto)
                ) && 
                (
                    this.AwstatsPrimaryDomain == other.AwstatsPrimaryDomain ||
                    this.AwstatsPrimaryDomain != null &&
                    this.AwstatsPrimaryDomain.Equals(other.AwstatsPrimaryDomain)
                ) && 
                (
                    this.SharepointMode == other.SharepointMode ||
                    this.SharepointMode != null &&
                    this.SharepointMode.Equals(other.SharepointMode)
                ) && 
                (
                    this.SharepointModePending == other.SharepointModePending ||
                    this.SharepointModePending != null &&
                    this.SharepointModePending.Equals(other.SharepointModePending)
                ) && 
                (
                    this.ApacheGenericPoolPort == other.ApacheGenericPoolPort ||
                    this.ApacheGenericPoolPort != null &&
                    this.ApacheGenericPoolPort.Equals(other.ApacheGenericPoolPort)
                ) && 
                (
                    this.MongrelEnvironment == other.MongrelEnvironment ||
                    this.MongrelEnvironment != null &&
                    this.MongrelEnvironment.Equals(other.MongrelEnvironment)
                ) && 
                (
                    this.FlagFree == other.FlagFree ||
                    this.FlagFree != null &&
                    this.FlagFree.Equals(other.FlagFree)
                ) && 
                (
                    this.RtmScanDate == other.RtmScanDate ||
                    this.RtmScanDate != null &&
                    this.RtmScanDate.Equals(other.RtmScanDate)
                ) && 
                (
                    this.AnalyzeAnalog == other.AnalyzeAnalog ||
                    this.AnalyzeAnalog != null &&
                    this.AnalyzeAnalog.Equals(other.AnalyzeAnalog)
                ) && 
                (
                    this.CpuDetailsEnabled == other.CpuDetailsEnabled ||
                    this.CpuDetailsEnabled != null &&
                    this.CpuDetailsEnabled.Equals(other.CpuDetailsEnabled)
                ) && 
                (
                    this.ContentModeratedStatus == other.ContentModeratedStatus ||
                    this.ContentModeratedStatus != null &&
                    this.ContentModeratedStatus.Equals(other.ContentModeratedStatus)
                ) && 
                (
                    this.ContentModeratedDate == other.ContentModeratedDate ||
                    this.ContentModeratedDate != null &&
                    this.ContentModeratedDate.Equals(other.ContentModeratedDate)
                ) && 
                (
                    this.HttpFrontendIp == other.HttpFrontendIp ||
                    this.HttpFrontendIp != null &&
                    this.HttpFrontendIp.Equals(other.HttpFrontendIp)
                ) && 
                (
                    this.HttpFrontendIpTransition == other.HttpFrontendIpTransition ||
                    this.HttpFrontendIpTransition != null &&
                    this.HttpFrontendIpTransition.Equals(other.HttpFrontendIpTransition)
                ) && 
                (
                    this.CpuLimitExceededDate == other.CpuLimitExceededDate ||
                    this.CpuLimitExceededDate != null &&
                    this.CpuLimitExceededDate.Equals(other.CpuLimitExceededDate)
                ) && 
                (
                    this.AufsTemplate == other.AufsTemplate ||
                    this.AufsTemplate != null &&
                    this.AufsTemplate.Equals(other.AufsTemplate)
                ) && 
                (
                    this.OptionsAutolimit == other.OptionsAutolimit ||
                    this.OptionsAutolimit != null &&
                    this.OptionsAutolimit.Equals(other.OptionsAutolimit)
                ) && 
                (
                    this.IisCreationCommands == other.IisCreationCommands ||
                    this.IisCreationCommands != null &&
                    this.IisCreationCommands.Equals(other.IisCreationCommands)
                ) && 
                (
                    this.IisCreationCommandsUnix == other.IisCreationCommandsUnix ||
                    this.IisCreationCommandsUnix != null &&
                    this.IisCreationCommandsUnix.Equals(other.IisCreationCommandsUnix)
                ) && 
                (
                    this.ThumbDate == other.ThumbDate ||
                    this.ThumbDate != null &&
                    this.ThumbDate.Equals(other.ThumbDate)
                ) && 
                (
                    this.ThumbFailed == other.ThumbFailed ||
                    this.ThumbFailed != null &&
                    this.ThumbFailed.Equals(other.ThumbFailed)
                ) && 
                (
                    this.BackupStatDate == other.BackupStatDate ||
                    this.BackupStatDate != null &&
                    this.BackupStatDate.Equals(other.BackupStatDate)
                ) && 
                (
                    this.BackupDate == other.BackupDate ||
                    this.BackupDate != null &&
                    this.BackupDate.Equals(other.BackupDate)
                ) && 
                (
                    this.DetectedPackages == other.DetectedPackages ||
                    this.DetectedPackages != null &&
                    this.DetectedPackages.Equals(other.DetectedPackages)
                ) && 
                (
                    this.StatSitePower == other.StatSitePower ||
                    this.StatSitePower != null &&
                    this.StatSitePower.Equals(other.StatSitePower)
                ) && 
                (
                    this.SmtpFrom == other.SmtpFrom ||
                    this.SmtpFrom != null &&
                    this.SmtpFrom.Equals(other.SmtpFrom)
                ) && 
                (
                    this.SuperBackupDate == other.SuperBackupDate ||
                    this.SuperBackupDate != null &&
                    this.SuperBackupDate.Equals(other.SuperBackupDate)
                ) && 
                (
                    this.BackupDeltaStatDate == other.BackupDeltaStatDate ||
                    this.BackupDeltaStatDate != null &&
                    this.BackupDeltaStatDate.Equals(other.BackupDeltaStatDate)
                ) && 
                (
                    this.BackupDeltaDate == other.BackupDeltaDate ||
                    this.BackupDeltaDate != null &&
                    this.BackupDeltaDate.Equals(other.BackupDeltaDate)
                ) && 
                (
                    this.BackupDeltaDesc == other.BackupDeltaDesc ||
                    this.BackupDeltaDesc != null &&
                    this.BackupDeltaDesc.Equals(other.BackupDeltaDesc)
                ) && 
                (
                    this.AltDocrootServer == other.AltDocrootServer ||
                    this.AltDocrootServer != null &&
                    this.AltDocrootServer.Equals(other.AltDocrootServer)
                ) && 
                (
                    this.AltDocrootPath == other.AltDocrootPath ||
                    this.AltDocrootPath != null &&
                    this.AltDocrootPath.Equals(other.AltDocrootPath)
                ) && 
                (
                    this.AltDocrootStatus == other.AltDocrootStatus ||
                    this.AltDocrootStatus != null &&
                    this.AltDocrootStatus.Equals(other.AltDocrootStatus)
                ) && 
                (
                    this.AltDocrootStatusCnt == other.AltDocrootStatusCnt ||
                    this.AltDocrootStatusCnt != null &&
                    this.AltDocrootStatusCnt.Equals(other.AltDocrootStatusCnt)
                ) && 
                (
                    this.AltDocrootStatusDate == other.AltDocrootStatusDate ||
                    this.AltDocrootStatusDate != null &&
                    this.AltDocrootStatusDate.Equals(other.AltDocrootStatusDate)
                ) && 
                (
                    this.BindDtc == other.BindDtc ||
                    this.BindDtc != null &&
                    this.BindDtc.Equals(other.BindDtc)
                ) && 
                (
                    this.BackupSpecialMode == other.BackupSpecialMode ||
                    this.BackupSpecialMode != null &&
                    this.BackupSpecialMode.Equals(other.BackupSpecialMode)
                ) && 
                (
                    this.SizeCheckProblem == other.SizeCheckProblem ||
                    this.SizeCheckProblem != null &&
                    this.SizeCheckProblem.Equals(other.SizeCheckProblem)
                ) && 
                (
                    this.WpbDomain == other.WpbDomain ||
                    this.WpbDomain != null &&
                    this.WpbDomain.Equals(other.WpbDomain)
                ) && 
                (
                    this.WpbUuid == other.WpbUuid ||
                    this.WpbUuid != null &&
                    this.WpbUuid.Equals(other.WpbUuid)
                ) && 
                (
                    this.WpbStatus == other.WpbStatus ||
                    this.WpbStatus != null &&
                    this.WpbStatus.Equals(other.WpbStatus)
                ) && 
                (
                    this.AdminProtection == other.AdminProtection ||
                    this.AdminProtection != null &&
                    this.AdminProtection.Equals(other.AdminProtection)
                ) && 
                (
                    this.SizeComments == other.SizeComments ||
                    this.SizeComments != null &&
                    this.SizeComments.Equals(other.SizeComments)
                ) && 
                (
                    this.AltDocrootSsdReq == other.AltDocrootSsdReq ||
                    this.AltDocrootSsdReq != null &&
                    this.AltDocrootSsdReq.Equals(other.AltDocrootSsdReq)
                ) && 
                (
                    this.MailLimit == other.MailLimit ||
                    this.MailLimit != null &&
                    this.MailLimit.Equals(other.MailLimit)
                ) && 
                (
                    this.MailAccept == other.MailAccept ||
                    this.MailAccept != null &&
                    this.MailAccept.Equals(other.MailAccept)
                ) && 
                (
                    this.MailDrop == other.MailDrop ||
                    this.MailDrop != null &&
                    this.MailDrop.Equals(other.MailDrop)
                ) && 
                (
                    this.FtpName == other.FtpName ||
                    this.FtpName != null &&
                    this.FtpName.Equals(other.FtpName)
                ) && 
                (
                    this.FtpPwd == other.FtpPwd ||
                    this.FtpPwd != null &&
                    this.FtpPwd.Equals(other.FtpPwd)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                    if (this.Unmovable != null)
                    hash = hash * 59 + this.Unmovable.GetHashCode();
                    if (this.Online != null)
                    hash = hash * 59 + this.Online.GetHashCode();
                    if (this.Deleted != null)
                    hash = hash * 59 + this.Deleted.GetHashCode();
                    if (this.DeletedAuto != null)
                    hash = hash * 59 + this.DeletedAuto.GetHashCode();
                    if (this.DeletedDump != null)
                    hash = hash * 59 + this.DeletedDump.GetHashCode();
                    if (this.UserId != null)
                    hash = hash * 59 + this.UserId.GetHashCode();
                    if (this.FtpId != null)
                    hash = hash * 59 + this.FtpId.GetHashCode();
                    if (this.DnsId != null)
                    hash = hash * 59 + this.DnsId.GetHashCode();
                    if (this.IisId != null)
                    hash = hash * 59 + this.IisId.GetHashCode();
                    if (this.IisBinding != null)
                    hash = hash * 59 + this.IisBinding.GetHashCode();
                    if (this.IisPath != null)
                    hash = hash * 59 + this.IisPath.GetHashCode();
                    if (this.IisComments != null)
                    hash = hash * 59 + this.IisComments.GetHashCode();
                    if (this.Memo != null)
                    hash = hash * 59 + this.Memo.GetHashCode();
                    if (this.DateReg != null)
                    hash = hash * 59 + this.DateReg.GetHashCode();
                    if (this.Server != null)
                    hash = hash * 59 + this.Server.GetHashCode();
                    if (this.ServerBak != null)
                    hash = hash * 59 + this.ServerBak.GetHashCode();
                    if (this.ServerAux != null)
                    hash = hash * 59 + this.ServerAux.GetHashCode();
                    if (this.ServerTransition != null)
                    hash = hash * 59 + this.ServerTransition.GetHashCode();
                    if (this.ServerTransitionDtc != null)
                    hash = hash * 59 + this.ServerTransitionDtc.GetHashCode();
                    if (this.BlockTransfer != null)
                    hash = hash * 59 + this.BlockTransfer.GetHashCode();
                    if (this.ServerChangedTime != null)
                    hash = hash * 59 + this.ServerChangedTime.GetHashCode();
                    if (this.SizeAmount != null)
                    hash = hash * 59 + this.SizeAmount.GetHashCode();
                    if (this.SizeFileCount != null)
                    hash = hash * 59 + this.SizeFileCount.GetHashCode();
                    if (this.SizeFileCountLimit != null)
                    hash = hash * 59 + this.SizeFileCountLimit.GetHashCode();
                    if (this.SizeDate != null)
                    hash = hash * 59 + this.SizeDate.GetHashCode();
                    if (this.SizePriorityScan != null)
                    hash = hash * 59 + this.SizePriorityScan.GetHashCode();
                    if (this.CopyLogs != null)
                    hash = hash * 59 + this.CopyLogs.GetHashCode();
                    if (this.ContentComments != null)
                    hash = hash * 59 + this.ContentComments.GetHashCode();
                    if (this.ContentCommentsVerbose != null)
                    hash = hash * 59 + this.ContentCommentsVerbose.GetHashCode();
                    if (this.MetaSaveCount != null)
                    hash = hash * 59 + this.MetaSaveCount.GetHashCode();
                    if (this.BaseFolder != null)
                    hash = hash * 59 + this.BaseFolder.GetHashCode();
                    if (this.VirtualhostConf != null)
                    hash = hash * 59 + this.VirtualhostConf.GetHashCode();
                    if (this.VirtualhostServer != null)
                    hash = hash * 59 + this.VirtualhostServer.GetHashCode();
                    if (this.VirtualhostServerConf != null)
                    hash = hash * 59 + this.VirtualhostServerConf.GetHashCode();
                    if (this.LiveDayCount != null)
                    hash = hash * 59 + this.LiveDayCount.GetHashCode();
                    if (this.ScanDate != null)
                    hash = hash * 59 + this.ScanDate.GetHashCode();
                    if (this.GlobalTransferCount != null)
                    hash = hash * 59 + this.GlobalTransferCount.GetHashCode();
                    if (this.NetLimitFile != null)
                    hash = hash * 59 + this.NetLimitFile.GetHashCode();
                    if (this.NetLimitDenyFromIp != null)
                    hash = hash * 59 + this.NetLimitDenyFromIp.GetHashCode();
                    if (this.NetLimitDenyFromAgent != null)
                    hash = hash * 59 + this.NetLimitDenyFromAgent.GetHashCode();
                    if (this.ApachePhpPooled != null)
                    hash = hash * 59 + this.ApachePhpPooled.GetHashCode();
                    if (this.ApachePhpPooledExt != null)
                    hash = hash * 59 + this.ApachePhpPooledExt.GetHashCode();
                    if (this.ApachePhpPooledExtAuto != null)
                    hash = hash * 59 + this.ApachePhpPooledExtAuto.GetHashCode();
                    if (this.ApachePhpPool1Only != null)
                    hash = hash * 59 + this.ApachePhpPool1Only.GetHashCode();
                    if (this.ApachePhpPool5Only != null)
                    hash = hash * 59 + this.ApachePhpPool5Only.GetHashCode();
                    if (this.ApacheSsi != null)
                    hash = hash * 59 + this.ApacheSsi.GetHashCode();
                    if (this.BypassSecurity != null)
                    hash = hash * 59 + this.BypassSecurity.GetHashCode();
                    if (this.FlagGenericExec != null)
                    hash = hash * 59 + this.FlagGenericExec.GetHashCode();
                    if (this.FlagNoWww != null)
                    hash = hash * 59 + this.FlagNoWww.GetHashCode();
                    if (this.BaseFolderSuffix != null)
                    hash = hash * 59 + this.BaseFolderSuffix.GetHashCode();
                    if (this.FeedbackSpeed != null)
                    hash = hash * 59 + this.FeedbackSpeed.GetHashCode();
                    if (this.FeedbackSpeedDtc != null)
                    hash = hash * 59 + this.FeedbackSpeedDtc.GetHashCode();
                    if (this.FeedbackSpeedFeedback != null)
                    hash = hash * 59 + this.FeedbackSpeedFeedback.GetHashCode();
                    if (this.UnixPathOnWindows != null)
                    hash = hash * 59 + this.UnixPathOnWindows.GetHashCode();
                    if (this.FtpIpfilter != null)
                    hash = hash * 59 + this.FtpIpfilter.GetHashCode();
                    if (this.SshIpfilter != null)
                    hash = hash * 59 + this.SshIpfilter.GetHashCode();
                    if (this.L3dAuto != null)
                    hash = hash * 59 + this.L3dAuto.GetHashCode();
                    if (this.AwstatsPrimaryDomain != null)
                    hash = hash * 59 + this.AwstatsPrimaryDomain.GetHashCode();
                    if (this.SharepointMode != null)
                    hash = hash * 59 + this.SharepointMode.GetHashCode();
                    if (this.SharepointModePending != null)
                    hash = hash * 59 + this.SharepointModePending.GetHashCode();
                    if (this.ApacheGenericPoolPort != null)
                    hash = hash * 59 + this.ApacheGenericPoolPort.GetHashCode();
                    if (this.MongrelEnvironment != null)
                    hash = hash * 59 + this.MongrelEnvironment.GetHashCode();
                    if (this.FlagFree != null)
                    hash = hash * 59 + this.FlagFree.GetHashCode();
                    if (this.RtmScanDate != null)
                    hash = hash * 59 + this.RtmScanDate.GetHashCode();
                    if (this.AnalyzeAnalog != null)
                    hash = hash * 59 + this.AnalyzeAnalog.GetHashCode();
                    if (this.CpuDetailsEnabled != null)
                    hash = hash * 59 + this.CpuDetailsEnabled.GetHashCode();
                    if (this.ContentModeratedStatus != null)
                    hash = hash * 59 + this.ContentModeratedStatus.GetHashCode();
                    if (this.ContentModeratedDate != null)
                    hash = hash * 59 + this.ContentModeratedDate.GetHashCode();
                    if (this.HttpFrontendIp != null)
                    hash = hash * 59 + this.HttpFrontendIp.GetHashCode();
                    if (this.HttpFrontendIpTransition != null)
                    hash = hash * 59 + this.HttpFrontendIpTransition.GetHashCode();
                    if (this.CpuLimitExceededDate != null)
                    hash = hash * 59 + this.CpuLimitExceededDate.GetHashCode();
                    if (this.AufsTemplate != null)
                    hash = hash * 59 + this.AufsTemplate.GetHashCode();
                    if (this.OptionsAutolimit != null)
                    hash = hash * 59 + this.OptionsAutolimit.GetHashCode();
                    if (this.IisCreationCommands != null)
                    hash = hash * 59 + this.IisCreationCommands.GetHashCode();
                    if (this.IisCreationCommandsUnix != null)
                    hash = hash * 59 + this.IisCreationCommandsUnix.GetHashCode();
                    if (this.ThumbDate != null)
                    hash = hash * 59 + this.ThumbDate.GetHashCode();
                    if (this.ThumbFailed != null)
                    hash = hash * 59 + this.ThumbFailed.GetHashCode();
                    if (this.BackupStatDate != null)
                    hash = hash * 59 + this.BackupStatDate.GetHashCode();
                    if (this.BackupDate != null)
                    hash = hash * 59 + this.BackupDate.GetHashCode();
                    if (this.DetectedPackages != null)
                    hash = hash * 59 + this.DetectedPackages.GetHashCode();
                    if (this.StatSitePower != null)
                    hash = hash * 59 + this.StatSitePower.GetHashCode();
                    if (this.SmtpFrom != null)
                    hash = hash * 59 + this.SmtpFrom.GetHashCode();
                    if (this.SuperBackupDate != null)
                    hash = hash * 59 + this.SuperBackupDate.GetHashCode();
                    if (this.BackupDeltaStatDate != null)
                    hash = hash * 59 + this.BackupDeltaStatDate.GetHashCode();
                    if (this.BackupDeltaDate != null)
                    hash = hash * 59 + this.BackupDeltaDate.GetHashCode();
                    if (this.BackupDeltaDesc != null)
                    hash = hash * 59 + this.BackupDeltaDesc.GetHashCode();
                    if (this.AltDocrootServer != null)
                    hash = hash * 59 + this.AltDocrootServer.GetHashCode();
                    if (this.AltDocrootPath != null)
                    hash = hash * 59 + this.AltDocrootPath.GetHashCode();
                    if (this.AltDocrootStatus != null)
                    hash = hash * 59 + this.AltDocrootStatus.GetHashCode();
                    if (this.AltDocrootStatusCnt != null)
                    hash = hash * 59 + this.AltDocrootStatusCnt.GetHashCode();
                    if (this.AltDocrootStatusDate != null)
                    hash = hash * 59 + this.AltDocrootStatusDate.GetHashCode();
                    if (this.BindDtc != null)
                    hash = hash * 59 + this.BindDtc.GetHashCode();
                    if (this.BackupSpecialMode != null)
                    hash = hash * 59 + this.BackupSpecialMode.GetHashCode();
                    if (this.SizeCheckProblem != null)
                    hash = hash * 59 + this.SizeCheckProblem.GetHashCode();
                    if (this.WpbDomain != null)
                    hash = hash * 59 + this.WpbDomain.GetHashCode();
                    if (this.WpbUuid != null)
                    hash = hash * 59 + this.WpbUuid.GetHashCode();
                    if (this.WpbStatus != null)
                    hash = hash * 59 + this.WpbStatus.GetHashCode();
                    if (this.AdminProtection != null)
                    hash = hash * 59 + this.AdminProtection.GetHashCode();
                    if (this.SizeComments != null)
                    hash = hash * 59 + this.SizeComments.GetHashCode();
                    if (this.AltDocrootSsdReq != null)
                    hash = hash * 59 + this.AltDocrootSsdReq.GetHashCode();
                    if (this.MailLimit != null)
                    hash = hash * 59 + this.MailLimit.GetHashCode();
                    if (this.MailAccept != null)
                    hash = hash * 59 + this.MailAccept.GetHashCode();
                    if (this.MailDrop != null)
                    hash = hash * 59 + this.MailDrop.GetHashCode();
                    if (this.FtpName != null)
                    hash = hash * 59 + this.FtpName.GetHashCode();
                    if (this.FtpPwd != null)
                    hash = hash * 59 + this.FtpPwd.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse20014 left, InlineResponse20014 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse20014 left, InlineResponse20014 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
