/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse2004 :  IEquatable<InlineResponse2004>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2004" /> class.
        /// </summary>
        /// <param name="DateUpdated">Дата последнего обновления домена (required).</param>
        /// <param name="RecordCreated">Дата создания записи (required).</param>
        /// <param name="SubjectContract"> (required).</param>
        /// <param name="EndDate"> (required).</param>
        /// <param name="PayedTill">Дата, до которой оплачен домен (required).</param>
        /// <param name="ObjectState"> (required).</param>
        /// <param name="DomainAddr">Имя домена (required).</param>
        /// <param name="Nservers">Сервера имён домена (required).</param>
        /// <param name="ExpiresCountdown">Количество дней до окончания срока действия домена (required).</param>
        public InlineResponse2004(string DateUpdated = null, string RecordCreated = null, string SubjectContract = null, string EndDate = null, string PayedTill = null, string ObjectState = null, string DomainAddr = null, string Nservers = null, int? ExpiresCountdown = null)
        {
            // to ensure "DateUpdated" is required (not null)
            if (DateUpdated == null)
            {
                throw new InvalidDataException("DateUpdated is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.DateUpdated = DateUpdated;
            }
            // to ensure "RecordCreated" is required (not null)
            if (RecordCreated == null)
            {
                throw new InvalidDataException("RecordCreated is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.RecordCreated = RecordCreated;
            }
            // to ensure "SubjectContract" is required (not null)
            if (SubjectContract == null)
            {
                throw new InvalidDataException("SubjectContract is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.SubjectContract = SubjectContract;
            }
            // to ensure "EndDate" is required (not null)
            if (EndDate == null)
            {
                throw new InvalidDataException("EndDate is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.EndDate = EndDate;
            }
            // to ensure "PayedTill" is required (not null)
            if (PayedTill == null)
            {
                throw new InvalidDataException("PayedTill is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.PayedTill = PayedTill;
            }
            // to ensure "ObjectState" is required (not null)
            if (ObjectState == null)
            {
                throw new InvalidDataException("ObjectState is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.ObjectState = ObjectState;
            }
            // to ensure "DomainAddr" is required (not null)
            if (DomainAddr == null)
            {
                throw new InvalidDataException("DomainAddr is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.DomainAddr = DomainAddr;
            }
            // to ensure "Nservers" is required (not null)
            if (Nservers == null)
            {
                throw new InvalidDataException("Nservers is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.Nservers = Nservers;
            }
            // to ensure "ExpiresCountdown" is required (not null)
            if (ExpiresCountdown == null)
            {
                throw new InvalidDataException("ExpiresCountdown is a required property for InlineResponse2004 and cannot be null");
            }
            else
            {
                this.ExpiresCountdown = ExpiresCountdown;
            }
            
        }

        /// <summary>
        /// Дата последнего обновления домена
        /// </summary>
        /// <value>Дата последнего обновления домена</value>
        public string DateUpdated { get; set; }

        /// <summary>
        /// Дата создания записи
        /// </summary>
        /// <value>Дата создания записи</value>
        public string RecordCreated { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string SubjectContract { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string EndDate { get; set; }

        /// <summary>
        /// Дата, до которой оплачен домен
        /// </summary>
        /// <value>Дата, до которой оплачен домен</value>
        public string PayedTill { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string ObjectState { get; set; }

        /// <summary>
        /// Имя домена
        /// </summary>
        /// <value>Имя домена</value>
        public string DomainAddr { get; set; }

        /// <summary>
        /// Сервера имён домена
        /// </summary>
        /// <value>Сервера имён домена</value>
        public string Nservers { get; set; }

        /// <summary>
        /// Количество дней до окончания срока действия домена
        /// </summary>
        /// <value>Количество дней до окончания срока действия домена</value>
        public int? ExpiresCountdown { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2004 {\n");
            sb.Append("  DateUpdated: ").Append(DateUpdated).Append("\n");
sb.Append("  RecordCreated: ").Append(RecordCreated).Append("\n");
sb.Append("  SubjectContract: ").Append(SubjectContract).Append("\n");
sb.Append("  EndDate: ").Append(EndDate).Append("\n");
sb.Append("  PayedTill: ").Append(PayedTill).Append("\n");
sb.Append("  ObjectState: ").Append(ObjectState).Append("\n");
sb.Append("  DomainAddr: ").Append(DomainAddr).Append("\n");
sb.Append("  Nservers: ").Append(Nservers).Append("\n");
sb.Append("  ExpiresCountdown: ").Append(ExpiresCountdown).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse2004)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse2004 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2004 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2004 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.DateUpdated == other.DateUpdated ||
                    this.DateUpdated != null &&
                    this.DateUpdated.Equals(other.DateUpdated)
                ) && 
                (
                    this.RecordCreated == other.RecordCreated ||
                    this.RecordCreated != null &&
                    this.RecordCreated.Equals(other.RecordCreated)
                ) && 
                (
                    this.SubjectContract == other.SubjectContract ||
                    this.SubjectContract != null &&
                    this.SubjectContract.Equals(other.SubjectContract)
                ) && 
                (
                    this.EndDate == other.EndDate ||
                    this.EndDate != null &&
                    this.EndDate.Equals(other.EndDate)
                ) && 
                (
                    this.PayedTill == other.PayedTill ||
                    this.PayedTill != null &&
                    this.PayedTill.Equals(other.PayedTill)
                ) && 
                (
                    this.ObjectState == other.ObjectState ||
                    this.ObjectState != null &&
                    this.ObjectState.Equals(other.ObjectState)
                ) && 
                (
                    this.DomainAddr == other.DomainAddr ||
                    this.DomainAddr != null &&
                    this.DomainAddr.Equals(other.DomainAddr)
                ) && 
                (
                    this.Nservers == other.Nservers ||
                    this.Nservers != null &&
                    this.Nservers.Equals(other.Nservers)
                ) && 
                (
                    this.ExpiresCountdown == other.ExpiresCountdown ||
                    this.ExpiresCountdown != null &&
                    this.ExpiresCountdown.Equals(other.ExpiresCountdown)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.DateUpdated != null)
                    hash = hash * 59 + this.DateUpdated.GetHashCode();
                    if (this.RecordCreated != null)
                    hash = hash * 59 + this.RecordCreated.GetHashCode();
                    if (this.SubjectContract != null)
                    hash = hash * 59 + this.SubjectContract.GetHashCode();
                    if (this.EndDate != null)
                    hash = hash * 59 + this.EndDate.GetHashCode();
                    if (this.PayedTill != null)
                    hash = hash * 59 + this.PayedTill.GetHashCode();
                    if (this.ObjectState != null)
                    hash = hash * 59 + this.ObjectState.GetHashCode();
                    if (this.DomainAddr != null)
                    hash = hash * 59 + this.DomainAddr.GetHashCode();
                    if (this.Nservers != null)
                    hash = hash * 59 + this.Nservers.GetHashCode();
                    if (this.ExpiresCountdown != null)
                    hash = hash * 59 + this.ExpiresCountdown.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse2004 left, InlineResponse2004 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse2004 left, InlineResponse2004 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
