/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse2006 :  IEquatable<InlineResponse2006>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2006" /> class.
        /// </summary>
        /// <param name="Id">идентификатор ящика (required).</param>
        /// <param name="Status"> (required).</param>
        /// <param name="Online">ящик работает, если true (required).</param>
        /// <param name="Mail">полный адрес ящика (required).</param>
        /// <param name="MercuryUser">имя пользователя для входа в Mercury (required).</param>
        /// <param name="MercuryPwd">пароль для входа в Mercury (required).</param>
        /// <param name="SizeAmount">текущий размер ящика (required).</param>
        /// <param name="SizeFileCount">количество файлов, занятых ящиком (required).</param>
        /// <param name="ArchivedCount"> (required).</param>
        /// <param name="ServerPop3">адрес сервера для доступа к ящику по POP3 (required).</param>
        /// <param name="ServerSmtp">адрес сервера для доступа к ящику по SMTP (required).</param>
        /// <param name="ServerWebmail">адрес сервера Webmail для входа в ящик через браузер (required).</param>
        /// <param name="ServerImap">адрес сервера для доступа к ящику по IMAP (required).</param>
        /// <param name="Wm1"> (required).</param>
        /// <param name="Wm2"> (required).</param>
        public InlineResponse2006(int? Id = null, int? Status = null, bool? Online = null, string Mail = null, string MercuryUser = null, string MercuryPwd = null, int? SizeAmount = null, int? SizeFileCount = null, int? ArchivedCount = null, string ServerPop3 = null, string ServerSmtp = null, string ServerWebmail = null, string ServerImap = null, string Wm1 = null, string Wm2 = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Status" is required (not null)
            if (Status == null)
            {
                throw new InvalidDataException("Status is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Status = Status;
            }
            // to ensure "Online" is required (not null)
            if (Online == null)
            {
                throw new InvalidDataException("Online is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Online = Online;
            }
            // to ensure "Mail" is required (not null)
            if (Mail == null)
            {
                throw new InvalidDataException("Mail is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Mail = Mail;
            }
            // to ensure "MercuryUser" is required (not null)
            if (MercuryUser == null)
            {
                throw new InvalidDataException("MercuryUser is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.MercuryUser = MercuryUser;
            }
            // to ensure "MercuryPwd" is required (not null)
            if (MercuryPwd == null)
            {
                throw new InvalidDataException("MercuryPwd is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.MercuryPwd = MercuryPwd;
            }
            // to ensure "SizeAmount" is required (not null)
            if (SizeAmount == null)
            {
                throw new InvalidDataException("SizeAmount is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.SizeAmount = SizeAmount;
            }
            // to ensure "SizeFileCount" is required (not null)
            if (SizeFileCount == null)
            {
                throw new InvalidDataException("SizeFileCount is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.SizeFileCount = SizeFileCount;
            }
            // to ensure "ArchivedCount" is required (not null)
            if (ArchivedCount == null)
            {
                throw new InvalidDataException("ArchivedCount is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.ArchivedCount = ArchivedCount;
            }
            // to ensure "ServerPop3" is required (not null)
            if (ServerPop3 == null)
            {
                throw new InvalidDataException("ServerPop3 is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.ServerPop3 = ServerPop3;
            }
            // to ensure "ServerSmtp" is required (not null)
            if (ServerSmtp == null)
            {
                throw new InvalidDataException("ServerSmtp is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.ServerSmtp = ServerSmtp;
            }
            // to ensure "ServerWebmail" is required (not null)
            if (ServerWebmail == null)
            {
                throw new InvalidDataException("ServerWebmail is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.ServerWebmail = ServerWebmail;
            }
            // to ensure "ServerImap" is required (not null)
            if (ServerImap == null)
            {
                throw new InvalidDataException("ServerImap is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.ServerImap = ServerImap;
            }
            // to ensure "Wm1" is required (not null)
            if (Wm1 == null)
            {
                throw new InvalidDataException("Wm1 is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Wm1 = Wm1;
            }
            // to ensure "Wm2" is required (not null)
            if (Wm2 == null)
            {
                throw new InvalidDataException("Wm2 is a required property for InlineResponse2006 and cannot be null");
            }
            else
            {
                this.Wm2 = Wm2;
            }
            
        }

        /// <summary>
        /// идентификатор ящика
        /// </summary>
        /// <value>идентификатор ящика</value>
        public int? Id { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? Status { get; set; }

        /// <summary>
        /// ящик работает, если true
        /// </summary>
        /// <value>ящик работает, если true</value>
        public bool? Online { get; set; }

        /// <summary>
        /// полный адрес ящика
        /// </summary>
        /// <value>полный адрес ящика</value>
        public string Mail { get; set; }

        /// <summary>
        /// имя пользователя для входа в Mercury
        /// </summary>
        /// <value>имя пользователя для входа в Mercury</value>
        public string MercuryUser { get; set; }

        /// <summary>
        /// пароль для входа в Mercury
        /// </summary>
        /// <value>пароль для входа в Mercury</value>
        public string MercuryPwd { get; set; }

        /// <summary>
        /// текущий размер ящика
        /// </summary>
        /// <value>текущий размер ящика</value>
        public int? SizeAmount { get; set; }

        /// <summary>
        /// количество файлов, занятых ящиком
        /// </summary>
        /// <value>количество файлов, занятых ящиком</value>
        public int? SizeFileCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public int? ArchivedCount { get; set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по POP3
        /// </summary>
        /// <value>адрес сервера для доступа к ящику по POP3</value>
        public string ServerPop3 { get; set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по SMTP
        /// </summary>
        /// <value>адрес сервера для доступа к ящику по SMTP</value>
        public string ServerSmtp { get; set; }

        /// <summary>
        /// адрес сервера Webmail для входа в ящик через браузер
        /// </summary>
        /// <value>адрес сервера Webmail для входа в ящик через браузер</value>
        public string ServerWebmail { get; set; }

        /// <summary>
        /// адрес сервера для доступа к ящику по IMAP
        /// </summary>
        /// <value>адрес сервера для доступа к ящику по IMAP</value>
        public string ServerImap { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Wm1 { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <value></value>
        public string Wm2 { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2006 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Status: ").Append(Status).Append("\n");
sb.Append("  Online: ").Append(Online).Append("\n");
sb.Append("  Mail: ").Append(Mail).Append("\n");
sb.Append("  MercuryUser: ").Append(MercuryUser).Append("\n");
sb.Append("  MercuryPwd: ").Append(MercuryPwd).Append("\n");
sb.Append("  SizeAmount: ").Append(SizeAmount).Append("\n");
sb.Append("  SizeFileCount: ").Append(SizeFileCount).Append("\n");
sb.Append("  ArchivedCount: ").Append(ArchivedCount).Append("\n");
sb.Append("  ServerPop3: ").Append(ServerPop3).Append("\n");
sb.Append("  ServerSmtp: ").Append(ServerSmtp).Append("\n");
sb.Append("  ServerWebmail: ").Append(ServerWebmail).Append("\n");
sb.Append("  ServerImap: ").Append(ServerImap).Append("\n");
sb.Append("  Wm1: ").Append(Wm1).Append("\n");
sb.Append("  Wm2: ").Append(Wm2).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse2006)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse2006 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2006 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2006 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.Online == other.Online ||
                    this.Online != null &&
                    this.Online.Equals(other.Online)
                ) && 
                (
                    this.Mail == other.Mail ||
                    this.Mail != null &&
                    this.Mail.Equals(other.Mail)
                ) && 
                (
                    this.MercuryUser == other.MercuryUser ||
                    this.MercuryUser != null &&
                    this.MercuryUser.Equals(other.MercuryUser)
                ) && 
                (
                    this.MercuryPwd == other.MercuryPwd ||
                    this.MercuryPwd != null &&
                    this.MercuryPwd.Equals(other.MercuryPwd)
                ) && 
                (
                    this.SizeAmount == other.SizeAmount ||
                    this.SizeAmount != null &&
                    this.SizeAmount.Equals(other.SizeAmount)
                ) && 
                (
                    this.SizeFileCount == other.SizeFileCount ||
                    this.SizeFileCount != null &&
                    this.SizeFileCount.Equals(other.SizeFileCount)
                ) && 
                (
                    this.ArchivedCount == other.ArchivedCount ||
                    this.ArchivedCount != null &&
                    this.ArchivedCount.Equals(other.ArchivedCount)
                ) && 
                (
                    this.ServerPop3 == other.ServerPop3 ||
                    this.ServerPop3 != null &&
                    this.ServerPop3.Equals(other.ServerPop3)
                ) && 
                (
                    this.ServerSmtp == other.ServerSmtp ||
                    this.ServerSmtp != null &&
                    this.ServerSmtp.Equals(other.ServerSmtp)
                ) && 
                (
                    this.ServerWebmail == other.ServerWebmail ||
                    this.ServerWebmail != null &&
                    this.ServerWebmail.Equals(other.ServerWebmail)
                ) && 
                (
                    this.ServerImap == other.ServerImap ||
                    this.ServerImap != null &&
                    this.ServerImap.Equals(other.ServerImap)
                ) && 
                (
                    this.Wm1 == other.Wm1 ||
                    this.Wm1 != null &&
                    this.Wm1.Equals(other.Wm1)
                ) && 
                (
                    this.Wm2 == other.Wm2 ||
                    this.Wm2 != null &&
                    this.Wm2.Equals(other.Wm2)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                    if (this.Online != null)
                    hash = hash * 59 + this.Online.GetHashCode();
                    if (this.Mail != null)
                    hash = hash * 59 + this.Mail.GetHashCode();
                    if (this.MercuryUser != null)
                    hash = hash * 59 + this.MercuryUser.GetHashCode();
                    if (this.MercuryPwd != null)
                    hash = hash * 59 + this.MercuryPwd.GetHashCode();
                    if (this.SizeAmount != null)
                    hash = hash * 59 + this.SizeAmount.GetHashCode();
                    if (this.SizeFileCount != null)
                    hash = hash * 59 + this.SizeFileCount.GetHashCode();
                    if (this.ArchivedCount != null)
                    hash = hash * 59 + this.ArchivedCount.GetHashCode();
                    if (this.ServerPop3 != null)
                    hash = hash * 59 + this.ServerPop3.GetHashCode();
                    if (this.ServerSmtp != null)
                    hash = hash * 59 + this.ServerSmtp.GetHashCode();
                    if (this.ServerWebmail != null)
                    hash = hash * 59 + this.ServerWebmail.GetHashCode();
                    if (this.ServerImap != null)
                    hash = hash * 59 + this.ServerImap.GetHashCode();
                    if (this.Wm1 != null)
                    hash = hash * 59 + this.Wm1.GetHashCode();
                    if (this.Wm2 != null)
                    hash = hash * 59 + this.Wm2.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse2006 left, InlineResponse2006 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse2006 left, InlineResponse2006 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
