/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse2008 :  IEquatable<InlineResponse2008>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2008" /> class.
        /// </summary>
        /// <param name="Id">идентификатор сайта (required).</param>
        /// <param name="Online">сайт работает нормально если true (required).</param>
        /// <param name="FtpId">идентификатор связанного аккаунта FTP (required).</param>
        /// <param name="DnsId">идентификатор связанной записи DNS (required).</param>
        /// <param name="SizeAmount">размер занятого места (required).</param>
        /// <param name="SizeFileCount">количество файлов (required).</param>
        /// <param name="SizeFileCountLimit">ограничение на количество файлов (required).</param>
        public InlineResponse2008(int? Id = null, bool? Online = null, int? FtpId = null, int? DnsId = null, int? SizeAmount = null, int? SizeFileCount = null, int? SizeFileCountLimit = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Online" is required (not null)
            if (Online == null)
            {
                throw new InvalidDataException("Online is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.Online = Online;
            }
            // to ensure "FtpId" is required (not null)
            if (FtpId == null)
            {
                throw new InvalidDataException("FtpId is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.FtpId = FtpId;
            }
            // to ensure "DnsId" is required (not null)
            if (DnsId == null)
            {
                throw new InvalidDataException("DnsId is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.DnsId = DnsId;
            }
            // to ensure "SizeAmount" is required (not null)
            if (SizeAmount == null)
            {
                throw new InvalidDataException("SizeAmount is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.SizeAmount = SizeAmount;
            }
            // to ensure "SizeFileCount" is required (not null)
            if (SizeFileCount == null)
            {
                throw new InvalidDataException("SizeFileCount is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.SizeFileCount = SizeFileCount;
            }
            // to ensure "SizeFileCountLimit" is required (not null)
            if (SizeFileCountLimit == null)
            {
                throw new InvalidDataException("SizeFileCountLimit is a required property for InlineResponse2008 and cannot be null");
            }
            else
            {
                this.SizeFileCountLimit = SizeFileCountLimit;
            }
            
        }

        /// <summary>
        /// идентификатор сайта
        /// </summary>
        /// <value>идентификатор сайта</value>
        public int? Id { get; set; }

        /// <summary>
        /// сайт работает нормально если true
        /// </summary>
        /// <value>сайт работает нормально если true</value>
        public bool? Online { get; set; }

        /// <summary>
        /// идентификатор связанного аккаунта FTP
        /// </summary>
        /// <value>идентификатор связанного аккаунта FTP</value>
        public int? FtpId { get; set; }

        /// <summary>
        /// идентификатор связанной записи DNS
        /// </summary>
        /// <value>идентификатор связанной записи DNS</value>
        public int? DnsId { get; set; }

        /// <summary>
        /// размер занятого места
        /// </summary>
        /// <value>размер занятого места</value>
        public int? SizeAmount { get; set; }

        /// <summary>
        /// количество файлов
        /// </summary>
        /// <value>количество файлов</value>
        public int? SizeFileCount { get; set; }

        /// <summary>
        /// ограничение на количество файлов
        /// </summary>
        /// <value>ограничение на количество файлов</value>
        public int? SizeFileCountLimit { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2008 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Online: ").Append(Online).Append("\n");
sb.Append("  FtpId: ").Append(FtpId).Append("\n");
sb.Append("  DnsId: ").Append(DnsId).Append("\n");
sb.Append("  SizeAmount: ").Append(SizeAmount).Append("\n");
sb.Append("  SizeFileCount: ").Append(SizeFileCount).Append("\n");
sb.Append("  SizeFileCountLimit: ").Append(SizeFileCountLimit).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse2008)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse2008 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2008 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2008 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Online == other.Online ||
                    this.Online != null &&
                    this.Online.Equals(other.Online)
                ) && 
                (
                    this.FtpId == other.FtpId ||
                    this.FtpId != null &&
                    this.FtpId.Equals(other.FtpId)
                ) && 
                (
                    this.DnsId == other.DnsId ||
                    this.DnsId != null &&
                    this.DnsId.Equals(other.DnsId)
                ) && 
                (
                    this.SizeAmount == other.SizeAmount ||
                    this.SizeAmount != null &&
                    this.SizeAmount.Equals(other.SizeAmount)
                ) && 
                (
                    this.SizeFileCount == other.SizeFileCount ||
                    this.SizeFileCount != null &&
                    this.SizeFileCount.Equals(other.SizeFileCount)
                ) && 
                (
                    this.SizeFileCountLimit == other.SizeFileCountLimit ||
                    this.SizeFileCountLimit != null &&
                    this.SizeFileCountLimit.Equals(other.SizeFileCountLimit)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Online != null)
                    hash = hash * 59 + this.Online.GetHashCode();
                    if (this.FtpId != null)
                    hash = hash * 59 + this.FtpId.GetHashCode();
                    if (this.DnsId != null)
                    hash = hash * 59 + this.DnsId.GetHashCode();
                    if (this.SizeAmount != null)
                    hash = hash * 59 + this.SizeAmount.GetHashCode();
                    if (this.SizeFileCount != null)
                    hash = hash * 59 + this.SizeFileCount.GetHashCode();
                    if (this.SizeFileCountLimit != null)
                    hash = hash * 59 + this.SizeFileCountLimit.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse2008 left, InlineResponse2008 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse2008 left, InlineResponse2008 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
