/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class InlineResponse2009 :  IEquatable<InlineResponse2009>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2009" /> class.
        /// </summary>
        /// <param name="Id">идентификатор аккаунта (required).</param>
        /// <param name="Db">имя базы данных (required).</param>
        /// <param name="Server">адрес сервера (required).</param>
        /// <param name="Name">логин (required).</param>
        /// <param name="Pwd">пароль (required).</param>
        public InlineResponse2009(int? Id = null, string Db = null, string Server = null, string Name = null, string Pwd = null)
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for InlineResponse2009 and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "Db" is required (not null)
            if (Db == null)
            {
                throw new InvalidDataException("Db is a required property for InlineResponse2009 and cannot be null");
            }
            else
            {
                this.Db = Db;
            }
            // to ensure "Server" is required (not null)
            if (Server == null)
            {
                throw new InvalidDataException("Server is a required property for InlineResponse2009 and cannot be null");
            }
            else
            {
                this.Server = Server;
            }
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for InlineResponse2009 and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            // to ensure "Pwd" is required (not null)
            if (Pwd == null)
            {
                throw new InvalidDataException("Pwd is a required property for InlineResponse2009 and cannot be null");
            }
            else
            {
                this.Pwd = Pwd;
            }
            
        }

        /// <summary>
        /// идентификатор аккаунта
        /// </summary>
        /// <value>идентификатор аккаунта</value>
        public int? Id { get; set; }

        /// <summary>
        /// имя базы данных
        /// </summary>
        /// <value>имя базы данных</value>
        public string Db { get; set; }

        /// <summary>
        /// адрес сервера
        /// </summary>
        /// <value>адрес сервера</value>
        public string Server { get; set; }

        /// <summary>
        /// логин
        /// </summary>
        /// <value>логин</value>
        public string Name { get; set; }

        /// <summary>
        /// пароль
        /// </summary>
        /// <value>пароль</value>
        public string Pwd { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2009 {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
sb.Append("  Db: ").Append(Db).Append("\n");
sb.Append("  Server: ").Append(Server).Append("\n");
sb.Append("  Name: ").Append(Name).Append("\n");
sb.Append("  Pwd: ").Append(Pwd).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((InlineResponse2009)obj);
        }

        /// <summary>
        /// Returns true if InlineResponse2009 instances are equal
        /// </summary>
        /// <param name="other">Instance of InlineResponse2009 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2009 other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Db == other.Db ||
                    this.Db != null &&
                    this.Db.Equals(other.Db)
                ) && 
                (
                    this.Server == other.Server ||
                    this.Server != null &&
                    this.Server.Equals(other.Server)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.Pwd == other.Pwd ||
                    this.Pwd != null &&
                    this.Pwd.Equals(other.Pwd)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Db != null)
                    hash = hash * 59 + this.Db.GetHashCode();
                    if (this.Server != null)
                    hash = hash * 59 + this.Server.GetHashCode();
                    if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                    if (this.Pwd != null)
                    hash = hash * 59 + this.Pwd.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(InlineResponse2009 left, InlineResponse2009 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(InlineResponse2009 left, InlineResponse2009 right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
