/*
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{
    /// <summary>
    /// 
    /// </summary>
    public partial class _ :  IEquatable<_>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="_" /> class.
        /// </summary>
        /// <param name="Mail">Ограничение на количество почтовых ящиков. &#39;-&#39; означает отсутствие лимита. (required).</param>
        /// <param name="Website">Ограничение на количество сайтов. &#39;-&#39; означает отсутствие лимита. (required).</param>
        /// <param name="Mysql">MySQL разрешен, если true. (required).</param>
        /// <param name="Size">Ограничение на размер дискового пространства. &#39;-&#39; означает отсутствие лимита. (required).</param>
        /// <param name="Mssql">MSSQL разрешен, если true. (required).</param>
        /// <param name="DynamicContent">CGI и PHP скрипты разрешены, если true. (required).</param>
        /// <param name="PhpExec">Функция exec() в PHP разрешена, если true. (required).</param>
        /// <param name="Ftp2">Ограничение на количество дополнительных FTP логинов. &#39;-&#39; означает отсутствие лимита. (required).</param>
        public _(string Mail = null, string Website = null, bool? Mysql = null, string Size = null, bool? Mssql = null, bool? DynamicContent = null, bool? PhpExec = null, string Ftp2 = null)
        {
            // to ensure "Mail" is required (not null)
            if (Mail == null)
            {
                throw new InvalidDataException("Mail is a required property for _ and cannot be null");
            }
            else
            {
                this.Mail = Mail;
            }
            // to ensure "Website" is required (not null)
            if (Website == null)
            {
                throw new InvalidDataException("Website is a required property for _ and cannot be null");
            }
            else
            {
                this.Website = Website;
            }
            // to ensure "Mysql" is required (not null)
            if (Mysql == null)
            {
                throw new InvalidDataException("Mysql is a required property for _ and cannot be null");
            }
            else
            {
                this.Mysql = Mysql;
            }
            // to ensure "Size" is required (not null)
            if (Size == null)
            {
                throw new InvalidDataException("Size is a required property for _ and cannot be null");
            }
            else
            {
                this.Size = Size;
            }
            // to ensure "Mssql" is required (not null)
            if (Mssql == null)
            {
                throw new InvalidDataException("Mssql is a required property for _ and cannot be null");
            }
            else
            {
                this.Mssql = Mssql;
            }
            // to ensure "DynamicContent" is required (not null)
            if (DynamicContent == null)
            {
                throw new InvalidDataException("DynamicContent is a required property for _ and cannot be null");
            }
            else
            {
                this.DynamicContent = DynamicContent;
            }
            // to ensure "PhpExec" is required (not null)
            if (PhpExec == null)
            {
                throw new InvalidDataException("PhpExec is a required property for _ and cannot be null");
            }
            else
            {
                this.PhpExec = PhpExec;
            }
            // to ensure "Ftp2" is required (not null)
            if (Ftp2 == null)
            {
                throw new InvalidDataException("Ftp2 is a required property for _ and cannot be null");
            }
            else
            {
                this.Ftp2 = Ftp2;
            }
            
        }

        /// <summary>
        /// Ограничение на количество почтовых ящиков. '-' означает отсутствие лимита.
        /// </summary>
        /// <value>Ограничение на количество почтовых ящиков. '-' означает отсутствие лимита.</value>
        public string Mail { get; set; }

        /// <summary>
        /// Ограничение на количество сайтов. '-' означает отсутствие лимита.
        /// </summary>
        /// <value>Ограничение на количество сайтов. '-' означает отсутствие лимита.</value>
        public string Website { get; set; }

        /// <summary>
        /// MySQL разрешен, если true.
        /// </summary>
        /// <value>MySQL разрешен, если true.</value>
        public bool? Mysql { get; set; }

        /// <summary>
        /// Ограничение на размер дискового пространства. '-' означает отсутствие лимита.
        /// </summary>
        /// <value>Ограничение на размер дискового пространства. '-' означает отсутствие лимита.</value>
        public string Size { get; set; }

        /// <summary>
        /// MSSQL разрешен, если true.
        /// </summary>
        /// <value>MSSQL разрешен, если true.</value>
        public bool? Mssql { get; set; }

        /// <summary>
        /// CGI и PHP скрипты разрешены, если true.
        /// </summary>
        /// <value>CGI и PHP скрипты разрешены, если true.</value>
        public bool? DynamicContent { get; set; }

        /// <summary>
        /// Функция exec() в PHP разрешена, если true.
        /// </summary>
        /// <value>Функция exec() в PHP разрешена, если true.</value>
        public bool? PhpExec { get; set; }

        /// <summary>
        /// Ограничение на количество дополнительных FTP логинов. '-' означает отсутствие лимита.
        /// </summary>
        /// <value>Ограничение на количество дополнительных FTP логинов. '-' означает отсутствие лимита.</value>
        public string Ftp2 { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class _ {\n");
            sb.Append("  Mail: ").Append(Mail).Append("\n");
sb.Append("  Website: ").Append(Website).Append("\n");
sb.Append("  Mysql: ").Append(Mysql).Append("\n");
sb.Append("  Size: ").Append(Size).Append("\n");
sb.Append("  Mssql: ").Append(Mssql).Append("\n");
sb.Append("  DynamicContent: ").Append(DynamicContent).Append("\n");
sb.Append("  PhpExec: ").Append(PhpExec).Append("\n");
sb.Append("  Ftp2: ").Append(Ftp2).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((_)obj);
        }

        /// <summary>
        /// Returns true if _ instances are equal
        /// </summary>
        /// <param name="other">Instance of _ to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(_ other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Mail == other.Mail ||
                    this.Mail != null &&
                    this.Mail.Equals(other.Mail)
                ) && 
                (
                    this.Website == other.Website ||
                    this.Website != null &&
                    this.Website.Equals(other.Website)
                ) && 
                (
                    this.Mysql == other.Mysql ||
                    this.Mysql != null &&
                    this.Mysql.Equals(other.Mysql)
                ) && 
                (
                    this.Size == other.Size ||
                    this.Size != null &&
                    this.Size.Equals(other.Size)
                ) && 
                (
                    this.Mssql == other.Mssql ||
                    this.Mssql != null &&
                    this.Mssql.Equals(other.Mssql)
                ) && 
                (
                    this.DynamicContent == other.DynamicContent ||
                    this.DynamicContent != null &&
                    this.DynamicContent.Equals(other.DynamicContent)
                ) && 
                (
                    this.PhpExec == other.PhpExec ||
                    this.PhpExec != null &&
                    this.PhpExec.Equals(other.PhpExec)
                ) && 
                (
                    this.Ftp2 == other.Ftp2 ||
                    this.Ftp2 != null &&
                    this.Ftp2.Equals(other.Ftp2)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Mail != null)
                    hash = hash * 59 + this.Mail.GetHashCode();
                    if (this.Website != null)
                    hash = hash * 59 + this.Website.GetHashCode();
                    if (this.Mysql != null)
                    hash = hash * 59 + this.Mysql.GetHashCode();
                    if (this.Size != null)
                    hash = hash * 59 + this.Size.GetHashCode();
                    if (this.Mssql != null)
                    hash = hash * 59 + this.Mssql.GetHashCode();
                    if (this.DynamicContent != null)
                    hash = hash * 59 + this.DynamicContent.GetHashCode();
                    if (this.PhpExec != null)
                    hash = hash * 59 + this.PhpExec.GetHashCode();
                    if (this.Ftp2 != null)
                    hash = hash * 59 + this.Ftp2.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(_ left, _ right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(_ left, _ right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
